/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !shift_count_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V1QImode:
      return pattern12 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern12 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern12 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern12 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern12 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern12 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern12 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern12 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern12 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (!register_operand (x2, E_V1SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1SImode)
        return -1;
      return 9;

    case E_V2SImode:
      if (!register_operand (x2, E_V2SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2SImode)
        return -1;
      return 10;

    case E_V4SImode:
      if (!register_operand (x2, E_V4SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      return 11;

    case E_V1DImode:
      if (!register_operand (x2, E_V1DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1DImode)
        return -1;
      return 12;

    case E_V2DImode:
      if (!register_operand (x2, E_V2DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2DImode)
        return -1;
      return 13;

    case E_V1TImode:
      if (!register_operand (x2, E_V1TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1TImode)
        return -1;
      return 14;

    case E_TImode:
      if (!register_operand (x2, E_TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TImode)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern30 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern30 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCRAWmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  return 0;
}

int
pattern37 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 0)
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern44 (rtx x1, int i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i3
      || XVECLEN (x2, 0) != i2
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern59 (rtx x1, int *pnum_clobbers, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern65 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern0 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern0 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern0 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern0 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern0 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern0 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern0 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern0 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern0 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern0 (x1, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern0 (x1, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern0 (x1, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern0 (x1, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern0 (x1, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1SFmode:
      if (pattern0 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 14;

    case E_V2SFmode:
      if (pattern0 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 15;

    case E_V4SFmode:
      if (pattern0 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 16;

    case E_V1DFmode:
      if (pattern0 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 17;

    case E_V2DFmode:
      if (pattern0 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 18;

    case E_V1TFmode:
      if (pattern0 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 19;

    case E_V1TImode:
      if (pattern0 (x1, 
E_V1TImode) != 0)
        return -1;
      return 20;

    case E_TImode:
      if (pattern0 (x1, 
E_TImode) != 0)
        return -1;
      return 21;

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_DImode) != 0)
        return -1;
      return 22;

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_HImode) != 0)
        return -1;
      return 23;

    case E_QImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_QImode) != 0)
        return -1;
      return 24;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern109 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern115 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern115 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern121 (x5, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern121 (x5, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_HImode:
      if (pattern121 (x5, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_QImode:
      if (pattern121 (x5, 
E_QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern130 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern142 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern148 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != ASHIFT
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != SUBREG
      || maybe_ne (SUBREG_BYTE (x7), 0)
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x6, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x9 = XEXP (x5, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x10 = XEXP (x3, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != i1
      || GET_MODE (x12) != E_DImode)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != SIGN_EXTEND
      || GET_MODE (x13) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  x14 = XEXP (x7, 0);
  operands[1] = x14;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x15 = XEXP (x11, 0);
  operands[0] = x15;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x16 = XEXP (x13, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  return 0;
}

int
pattern161 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) != PC)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  return pattern170 (); /* [-1, 1] */
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !memory_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern185 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 4;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern200 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern208 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern219 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern227 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern237 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern241 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern247 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern256 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern264 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern273 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern278 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern288 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || pattern285 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern295 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern25 (x1, 
E_CCRAWmode) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 347; /* *vec_test_maskv16qi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 348; /* *vec_test_maskv8hi */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 349; /* *vec_test_maskv4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 350; /* *vec_test_maskv2di */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 351; /* *vec_test_maskv1ti */

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 352; /* *vec_test_maskti */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 353; /* *vec_test_maskv2df */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 354; /* *vec_test_maskv4sf */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || !register_operand (operands[1], E_V1TImode)
          || !(
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 355; /* *vec_test_maskv1tf */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TImode)
          || !(
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 356; /* *vec_test_masktf */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern24 (x1))
    {
    case 0:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1097; /* *vec_slbv16qi */

    case 1:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1098; /* *vec_slbv8hi */

    case 2:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1099; /* *vec_slbv4si */

    case 3:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1100; /* *vec_slbv2di */

    case 4:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1101; /* *vec_slbv1ti */

    case 5:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1102; /* *vec_slbti */

    case 6:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1103; /* *vec_slbv4sf */

    case 7:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1104; /* *vec_slbv2df */

    case 8:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1105; /* *vec_slbv1tf */

    case 9:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1106; /* *vec_slbtf */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x8 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      switch (XWINT (x8, 0))
        {
        case 0L:
          switch (XWINT (x9, 0))
            {
            case 3L:
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (pattern220 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                      || !
#line 786 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 657; /* vpdi1v2di */

                case E_V2DFmode:
                  if (pattern220 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                      || !
#line 786 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 658; /* vpdi1v2df */

                default:
                  return -1;
                }

            case 2L:
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (pattern220 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                      || !
#line 913 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 673; /* *vmrhg */

                case E_V2DFmode:
                  if (pattern220 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                      || !
#line 913 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 674; /* *vmrhg */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1L:
          switch (XWINT (x9, 0))
            {
            case 2L:
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (pattern220 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                      || !
#line 798 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 659; /* vpdi4v2di */

                case E_V2DFmode:
                  if (pattern220 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                      || !
#line 798 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 660; /* vpdi4v2df */

                default:
                  return -1;
                }

            case 3L:
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (pattern220 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                      || !
#line 923 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 675; /* *vmrlg */

                case E_V2DFmode:
                  if (pattern220 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                      || !
#line 923 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 676; /* *vmrlg */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      x8 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      switch (XWINT (x8, 0))
        {
        case 2L:
          switch (XWINT (x9, 0))
            {
            case 3L:
              if (XWINT (x10, 0) != 4L
                  || XWINT (x11, 0) != 5L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern220 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 661; /* vpdi4_2v4si */

                case E_V4SFmode:
                  if (pattern220 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 662; /* vpdi4_2v4sf */

                default:
                  return -1;
                }

            case 6L:
              if (XWINT (x10, 0) != 3L
                  || XWINT (x11, 0) != 7L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern220 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 903 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 671; /* *vmrlf */

                case E_V4SFmode:
                  if (pattern220 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 903 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 672; /* *vmrlf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 0L:
          if (XWINT (x10, 0) != 1L)
            return -1;
          switch (XWINT (x9, 0))
            {
            case 4L:
              if (XWINT (x11, 0) != 5L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern220 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 881 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 667; /* *vmrhf */

                case E_V4SFmode:
                  if (pattern220 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 881 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 668; /* *vmrhf */

                default:
                  return -1;
                }

            case 2L:
              if (XWINT (x11, 0) != 3L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern107 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                      || !
#line 892 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 669; /* *vmrhf_halfv4si */

                case E_V4SFmode:
                  if (pattern107 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                      || !
#line 892 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 670; /* *vmrhf_halfv4sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 16:
      if (pattern129 (x3) != 0)
        return -1;
      x12 = XVECEXP (x3, 0, 8);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x13 = XVECEXP (x3, 0, 9);
      if (GET_CODE (x13) != CONST_INT)
        return -1;
      x14 = XVECEXP (x3, 0, 10);
      if (GET_CODE (x14) != CONST_INT)
        return -1;
      x15 = XVECEXP (x3, 0, 11);
      if (GET_CODE (x15) != CONST_INT)
        return -1;
      x16 = XVECEXP (x3, 0, 12);
      if (GET_CODE (x16) != CONST_INT)
        return -1;
      x17 = XVECEXP (x3, 0, 13);
      if (GET_CODE (x17) != CONST_INT)
        return -1;
      x18 = XVECEXP (x3, 0, 14);
      if (GET_CODE (x18) != CONST_INT)
        return -1;
      x19 = XVECEXP (x3, 0, 15);
      if (GET_CODE (x19) != CONST_INT
          || pattern220 (x2, 
E_V16QImode, 
E_V32QImode) != 0)
        return -1;
      x8 = XVECEXP (x3, 0, 0);
      switch (XWINT (x8, 0))
        {
        case 0L:
          x9 = XVECEXP (x3, 0, 1);
          if (XWINT (x9, 0) != 16L)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (XWINT (x10, 0) != 1L)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (XWINT (x11, 0) != 17L)
            return -1;
          x20 = XVECEXP (x3, 0, 4);
          if (XWINT (x20, 0) != 2L)
            return -1;
          x21 = XVECEXP (x3, 0, 5);
          if (XWINT (x21, 0) != 18L)
            return -1;
          x22 = XVECEXP (x3, 0, 6);
          if (XWINT (x22, 0) != 3L)
            return -1;
          x23 = XVECEXP (x3, 0, 7);
          if (XWINT (x23, 0) != 19L
              || XWINT (x12, 0) != 4L
              || XWINT (x13, 0) != 20L
              || XWINT (x14, 0) != 5L
              || XWINT (x15, 0) != 21L
              || XWINT (x16, 0) != 6L
              || XWINT (x17, 0) != 22L
              || XWINT (x18, 0) != 7L
              || XWINT (x19, 0) != 23L
              || !
#line 827 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 663; /* *vmrhb */

        case 8L:
          x9 = XVECEXP (x3, 0, 1);
          if (XWINT (x9, 0) != 24L)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (XWINT (x10, 0) != 9L)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (XWINT (x11, 0) != 25L)
            return -1;
          x20 = XVECEXP (x3, 0, 4);
          if (XWINT (x20, 0) != 10L)
            return -1;
          x21 = XVECEXP (x3, 0, 5);
          if (XWINT (x21, 0) != 26L)
            return -1;
          x22 = XVECEXP (x3, 0, 6);
          if (XWINT (x22, 0) != 11L)
            return -1;
          x23 = XVECEXP (x3, 0, 7);
          if (XWINT (x23, 0) != 27L
              || XWINT (x12, 0) != 12L
              || XWINT (x13, 0) != 28L
              || XWINT (x14, 0) != 13L
              || XWINT (x15, 0) != 29L
              || XWINT (x16, 0) != 14L
              || XWINT (x17, 0) != 30L
              || XWINT (x18, 0) != 15L
              || XWINT (x19, 0) != 31L
              || !
#line 844 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 664; /* *vmrlb */

        default:
          return -1;
        }

    case 8:
      if (pattern129 (x3) != 0
          || pattern220 (x2, 
E_V8HImode, 
E_V16HImode) != 0)
        return -1;
      x8 = XVECEXP (x3, 0, 0);
      switch (XWINT (x8, 0))
        {
        case 0L:
          x9 = XVECEXP (x3, 0, 1);
          if (XWINT (x9, 0) != 8L)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (XWINT (x10, 0) != 1L)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (XWINT (x11, 0) != 9L)
            return -1;
          x20 = XVECEXP (x3, 0, 4);
          if (XWINT (x20, 0) != 2L)
            return -1;
          x21 = XVECEXP (x3, 0, 5);
          if (XWINT (x21, 0) != 10L)
            return -1;
          x22 = XVECEXP (x3, 0, 6);
          if (XWINT (x22, 0) != 3L)
            return -1;
          x23 = XVECEXP (x3, 0, 7);
          if (XWINT (x23, 0) != 11L
              || !
#line 857 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 665; /* *vmrhh */

        case 4L:
          x9 = XVECEXP (x3, 0, 1);
          if (XWINT (x9, 0) != 12L)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (XWINT (x10, 0) != 5L)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (XWINT (x11, 0) != 13L)
            return -1;
          x20 = XVECEXP (x3, 0, 4);
          if (XWINT (x20, 0) != 6L)
            return -1;
          x21 = XVECEXP (x3, 0, 5);
          if (XWINT (x21, 0) != 14L)
            return -1;
          x22 = XVECEXP (x3, 0, 6);
          if (XWINT (x22, 0) != 7L)
            return -1;
          x23 = XVECEXP (x3, 0, 7);
          if (XWINT (x23, 0) != 15L
              || !
#line 870 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 666; /* *vmrlh */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (pattern204 (x2, 
E_V1QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1QImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1413; /* vec_sel0v1qi */
      if (!all_ones_operand (operands[4], E_V1QImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1454; /* *vec_sel1v1qi */

    case E_V2QImode:
      if (pattern204 (x2, 
E_V2QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2QImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1414; /* vec_sel0v2qi */
      if (!all_ones_operand (operands[4], E_V2QImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1455; /* *vec_sel1v2qi */

    case E_V4QImode:
      if (pattern204 (x2, 
E_V4QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4QImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1415; /* vec_sel0v4qi */
      if (!all_ones_operand (operands[4], E_V4QImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1456; /* *vec_sel1v4qi */

    case E_V8QImode:
      if (pattern204 (x2, 
E_V8QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V8QImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1416; /* vec_sel0v8qi */
      if (!all_ones_operand (operands[4], E_V8QImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1457; /* *vec_sel1v8qi */

    case E_V16QImode:
      if (pattern204 (x2, 
E_V16QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V16QImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1417; /* vec_sel0v16qi */
      if (!all_ones_operand (operands[4], E_V16QImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1458; /* *vec_sel1v16qi */

    case E_V1HImode:
      if (pattern204 (x2, 
E_V1HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1HImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1418; /* vec_sel0v1hi */
      if (!all_ones_operand (operands[4], E_V1HImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1459; /* *vec_sel1v1hi */

    case E_V2HImode:
      if (pattern204 (x2, 
E_V2HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2HImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1419; /* vec_sel0v2hi */
      if (!all_ones_operand (operands[4], E_V2HImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1460; /* *vec_sel1v2hi */

    case E_V4HImode:
      if (pattern204 (x2, 
E_V4HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4HImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1420; /* vec_sel0v4hi */
      if (!all_ones_operand (operands[4], E_V4HImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1461; /* *vec_sel1v4hi */

    case E_V8HImode:
      if (pattern204 (x2, 
E_V8HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V8HImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1421; /* vec_sel0v8hi */
      if (!all_ones_operand (operands[4], E_V8HImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1462; /* *vec_sel1v8hi */

    case E_V1SImode:
      if (pattern204 (x2, 
E_V1SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1SImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1422; /* vec_sel0v1si */
      if (!all_ones_operand (operands[4], E_V1SImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1463; /* *vec_sel1v1si */

    case E_V2SImode:
      if (pattern204 (x2, 
E_V2SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2SImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1423; /* vec_sel0v2si */
      if (!all_ones_operand (operands[4], E_V2SImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1464; /* *vec_sel1v2si */

    case E_V4SImode:
      if (pattern204 (x2, 
E_V4SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4SImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1424; /* vec_sel0v4si */
      if (!all_ones_operand (operands[4], E_V4SImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1465; /* *vec_sel1v4si */

    case E_V1DImode:
      if (pattern204 (x2, 
E_V1DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1DImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1425; /* vec_sel0v1di */
      if (!all_ones_operand (operands[4], E_V1DImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1466; /* *vec_sel1v1di */

    case E_V2DImode:
      if (pattern204 (x2, 
E_V2DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2DImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1426; /* vec_sel0v2di */
      if (!all_ones_operand (operands[4], E_V2DImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1467; /* *vec_sel1v2di */

    case E_V1SFmode:
      if (pattern205 (x2, 
E_V1SFmode, 
E_V1SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1SImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1427; /* vec_sel0v1sf */
      if (!all_ones_operand (operands[4], E_V1SImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1468; /* *vec_sel1v1sf */

    case E_V2SFmode:
      if (pattern205 (x2, 
E_V2SFmode, 
E_V2SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2SImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1428; /* vec_sel0v2sf */
      if (!all_ones_operand (operands[4], E_V2SImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1469; /* *vec_sel1v2sf */

    case E_V4SFmode:
      if (pattern205 (x2, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4SImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1429; /* vec_sel0v4sf */
      if (!all_ones_operand (operands[4], E_V4SImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1470; /* *vec_sel1v4sf */

    case E_V1DFmode:
      if (pattern205 (x2, 
E_V1DFmode, 
E_V1DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1DImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1430; /* vec_sel0v1df */
      if (!all_ones_operand (operands[4], E_V1DImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1471; /* *vec_sel1v1df */

    case E_V2DFmode:
      if (pattern205 (x2, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2DImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1431; /* vec_sel0v2df */
      if (!all_ones_operand (operands[4], E_V2DImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1472; /* *vec_sel1v2df */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x2) != E_V1TFmode
          || !register_operand (operands[3], E_V1TImode)
          || !const0_operand (operands[4], E_V1TImode)
          || !register_operand (operands[1], E_V1TFmode)
          || !register_operand (operands[2], E_V1TFmode)
          || !
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1432; /* vec_sel0v1tf */

    case E_V1TImode:
      if (pattern206 (x2, 
E_V1TImode) != 0
          || !
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1433; /* vec_sel0v1ti */

    case E_TImode:
      if (pattern206 (x2, 
E_TImode) != 0
          || !
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1434; /* vec_sel0ti */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!nonimmediate_operand (operands[0], E_V16QImode)
          || !general_operand (operands[1], E_V16QImode))
        return -1;
      return 521; /* movv16qi */

    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || !general_operand (operands[1], E_V8HImode))
        return -1;
      return 522; /* movv8hi */

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || !general_operand (operands[1], E_V4SImode))
        return -1;
      return 523; /* movv4si */

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !general_operand (operands[1], E_V4SFmode))
        return -1;
      return 524; /* movv4sf */

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || !general_operand (operands[1], E_V2DImode))
        return -1;
      return 525; /* movv2di */

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !general_operand (operands[1], E_V2DFmode))
        return -1;
      return 526; /* movv2df */

    case E_V1TImode:
      if (!nonimmediate_operand (operands[0], E_V1TImode)
          || !general_operand (operands[1], E_V1TImode))
        return -1;
      return 527; /* movv1ti */

    case E_V1TFmode:
      if (!nonimmediate_operand (operands[0], E_V1TFmode)
          || !general_operand (operands[1], E_V1TFmode))
        return -1;
      return 528; /* movv1tf */

    case E_TFmode:
      if (!nonimmediate_operand (operands[0], E_TFmode)
          || !general_operand (operands[1], E_TFmode)
          || !
#line 95 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 529; /* movtf_vr */

    case E_V1QImode:
      if (!nonimmediate_operand (operands[0], E_V1QImode)
          || !general_operand (operands[1], E_V1QImode)
          || !
#line 370 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 530; /* movv1qi */

    case E_V2QImode:
      if (!nonimmediate_operand (operands[0], E_V2QImode)
          || !general_operand (operands[1], E_V2QImode))
        return -1;
      return 531; /* movv2qi */

    case E_V1HImode:
      if (!nonimmediate_operand (operands[0], E_V1HImode)
          || !general_operand (operands[1], E_V1HImode))
        return -1;
      return 532; /* movv1hi */

    case E_V4QImode:
      if (!nonimmediate_operand (operands[0], E_V4QImode)
          || !general_operand (operands[1], E_V4QImode)
          || !
#line 425 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 533; /* movv4qi */

    case E_V2HImode:
      if (!nonimmediate_operand (operands[0], E_V2HImode)
          || !general_operand (operands[1], E_V2HImode)
          || !
#line 425 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 534; /* movv2hi */

    case E_V1SImode:
      if (!nonimmediate_operand (operands[0], E_V1SImode)
          || !general_operand (operands[1], E_V1SImode)
          || !
#line 425 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 535; /* movv1si */

    case E_V1SFmode:
      if (!nonimmediate_operand (operands[0], E_V1SFmode)
          || !general_operand (operands[1], E_V1SFmode)
          || !
#line 425 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 536; /* movv1sf */

    case E_V8QImode:
      if (!nonimmediate_operand (operands[0], E_V8QImode)
          || !general_operand (operands[1], E_V8QImode)
          || !
#line 462 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 537; /* movv8qi */

    case E_V4HImode:
      if (!nonimmediate_operand (operands[0], E_V4HImode)
          || !general_operand (operands[1], E_V4HImode)
          || !
#line 462 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 538; /* movv4hi */

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !general_operand (operands[1], E_V2SImode)
          || !
#line 462 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 539; /* movv2si */

    case E_V2SFmode:
      if (!nonimmediate_operand (operands[0], E_V2SFmode)
          || !general_operand (operands[1], E_V2SFmode)
          || !
#line 462 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 540; /* movv2sf */

    case E_V1DImode:
      if (!nonimmediate_operand (operands[0], E_V1DImode)
          || !general_operand (operands[1], E_V1DImode)
          || !
#line 462 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 541; /* movv1di */

    case E_V1DFmode:
      if (!nonimmediate_operand (operands[0], E_V1DFmode)
          || !general_operand (operands[1], E_V1DFmode)
          || !
#line 462 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 542; /* movv1df */

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !reload_const_wide_int_operand (operands[1], E_TImode)
          || !
#line 1757 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 1809; /* *movti_bigconst */

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !general_operand (operands[1], E_DImode))
        return -1;
      if (
#line 1972 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1811; /* *movdi_64 */
      if (!
#line 2213 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1844; /* *movdi_31 */

    case E_SImode:
      if (register_operand (operands[0], E_SImode)
          && larl_operand (operands[1], E_SImode)
          && 
#line 2394 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT
   && !FP_REG_P (operands[0])))
        return 1846; /* *movsi_larl */
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !general_operand (operands[1], E_SImode))
        return -1;
      if (
#line 2407 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1847; /* *movsi_zarch */
      if (!
#line 2498 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1848; /* *movsi_esa */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !general_operand (operands[1], E_HImode))
        return -1;
      return 1853; /* *movhi */

    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !general_operand (operands[1], E_QImode))
        return -1;
      return 1854; /* *movqi */

    case E_FPRX2mode:
      if (!nonimmediate_operand (operands[0], E_FPRX2mode)
          || !general_operand (operands[1], E_FPRX2mode))
        return -1;
      if ((
#line 2793 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 764 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return 1859; /* *movfprx2_64 */
      if (!(
#line 2810 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 764 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 1862; /* *movfprx2_31 */

    case E_TDmode:
      if (!nonimmediate_operand (operands[0], E_TDmode)
          || !general_operand (operands[1], E_TDmode))
        return -1;
      if (
#line 2793 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1860; /* *movtd_64 */
      if (!
#line 2810 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1863; /* *movtd_31 */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !general_operand (operands[1], E_DFmode))
        return -1;
      if (
#line 2917 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
        return 1864; /* *movdf_64dfp */
      if (
#line 2949 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1866; /* *movdf_64 */
      if (!
#line 2975 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1868; /* *movdf_31 */

    case E_DDmode:
      if (!nonimmediate_operand (operands[0], E_DDmode)
          || !general_operand (operands[1], E_DDmode))
        return -1;
      if (
#line 2917 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
        return 1865; /* *movdd_64dfp */
      if (
#line 2949 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1867; /* *movdd_64 */
      if (!
#line 2975 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1869; /* *movdd_31 */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !general_operand (operands[1], E_SFmode))
        return -1;
      return 1870; /* movsf */

    case E_SDmode:
      if (!nonimmediate_operand (operands[0], E_SDmode)
          || !general_operand (operands[1], E_SDmode))
        return -1;
      return 1871; /* movsd */

    case E_CCmode:
      if (!nonimmediate_operand (operands[0], E_CCmode)
          || !nonimmediate_operand (operands[1], E_CCmode))
        return -1;
      return 1872; /* movcc */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (!register_operand (operands[0], E_V1QImode)
              || GET_MODE (x3) != E_V1QImode
              || !register_operand (operands[1], E_V1QImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 738; /* negv1qi2 */

        case E_V2QImode:
          if (!register_operand (operands[0], E_V2QImode)
              || GET_MODE (x3) != E_V2QImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 739; /* negv2qi2 */

        case E_V4QImode:
          if (!register_operand (operands[0], E_V4QImode)
              || GET_MODE (x3) != E_V4QImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 740; /* negv4qi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 741; /* negv8qi2 */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 742; /* negv16qi2 */

        case E_V1HImode:
          if (!register_operand (operands[0], E_V1HImode)
              || GET_MODE (x3) != E_V1HImode
              || !register_operand (operands[1], E_V1HImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 743; /* negv1hi2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 744; /* negv2hi2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 745; /* negv4hi2 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 746; /* negv8hi2 */

        case E_V1SImode:
          if (!register_operand (operands[0], E_V1SImode)
              || GET_MODE (x3) != E_V1SImode
              || !register_operand (operands[1], E_V1SImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 747; /* negv1si2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 748; /* negv2si2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 749; /* negv4si2 */

        case E_V1DImode:
          if (!register_operand (operands[0], E_V1DImode)
              || GET_MODE (x3) != E_V1DImode
              || !register_operand (operands[1], E_V1DImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 750; /* negv1di2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 751; /* negv2di2 */

        case E_V1SFmode:
          if (!register_operand (operands[0], E_V1SFmode)
              || GET_MODE (x3) != E_V1SFmode
              || !register_operand (operands[1], E_V1SFmode)
              || !(
#line 1972 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1263; /* negv1sf2 */

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !(
#line 1972 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1264; /* negv2sf2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !(
#line 1972 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1265; /* negv4sf2 */

        case E_V1DFmode:
          if (!register_operand (operands[0], E_V1DFmode)
              || GET_MODE (x3) != E_V1DFmode
              || !register_operand (operands[1], E_V1DFmode)
              || !
#line 1972 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1266; /* negv1df2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 1972 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1267; /* negv2df2 */

        case E_V1TFmode:
          if (!register_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !register_operand (operands[1], E_V1TFmode)
              || !(
#line 1972 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1268; /* negv1tf2 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || !register_operand (operands[1], E_TFmode))
            return -1;
          if ((
#line 1972 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1269; /* negtf2_vr */
          if ((
#line 9252 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 2433; /* *negtf2_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9264 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2439; /* *negtf2 */

        case E_DImode:
          if (pattern83 (x3, pnum_clobbers, 
E_DImode) != 0)
            return -1;
          if (
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            {
              *pnum_clobbers = 1;
              return 2422; /* *negdi2 */
            }
          if (!
#line 9141 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2424; /* *negdi2_31 */

        case E_SImode:
          if (pattern83 (x3, pnum_clobbers, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 2423; /* *negsi2 */

        case E_FPRX2mode:
          if (!register_operand (operands[0], E_FPRX2mode)
              || GET_MODE (x3) != E_FPRX2mode
              || !register_operand (operands[1], E_FPRX2mode))
            return -1;
          if ((
#line 9252 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 2434; /* *negfprx22_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9264 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2440; /* *negfprx22 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 9252 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2435; /* *negdf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9264 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2441; /* *negdf2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 9252 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2436; /* *negsf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9264 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2442; /* *negsf2 */

        case E_TDmode:
          if (!register_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !register_operand (operands[1], E_TDmode)
              || !(
#line 9252 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2437; /* *negtd2_nocc */

        case E_DDmode:
          if (!register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_DDmode)
              || !(
#line 9252 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2438; /* *negdd2_nocc */

        default:
          return -1;
        }

    case FMA:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 2);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern156 (x3, 
E_V4SFmode) != 0
                  || !(
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V4SFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1255; /* neg_fmav4sf4 */

            case E_V2DFmode:
              if (pattern156 (x3, 
E_V2DFmode) != 0
                  || !
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V2DFmode)))
                return -1;
              return 1256; /* neg_fmav2df4 */

            case E_V1TFmode:
              if (pattern156 (x3, 
E_V1TFmode) != 0
                  || !(
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V1TFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1257; /* neg_fmav1tf4 */

            case E_TFmode:
              if (pattern156 (x3, 
E_TFmode) != 0
                  || !(
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (TFmode)) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1258; /* neg_fmatf4 */

            default:
              return -1;
            }

        case NEG:
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern157 (x3, 
E_V4SFmode) != 0
                  || !(
#line 1964 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V4SFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1259; /* neg_fmsv4sf4 */

            case E_V2DFmode:
              if (pattern157 (x3, 
E_V2DFmode) != 0
                  || !
#line 1964 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V2DFmode)))
                return -1;
              return 1260; /* neg_fmsv2df4 */

            case E_V1TFmode:
              if (pattern157 (x3, 
E_V1TFmode) != 0
                  || !(
#line 1964 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V1TFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1261; /* neg_fmsv1tf4 */

            case E_TFmode:
              if (pattern157 (x3, 
E_TFmode) != 0
                  || !(
#line 1964 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (TFmode)) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1262; /* neg_fmstf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V1SFmode:
              if (pattern109 (x3, 
E_V1SFmode) != 0
                  || !(
#line 2000 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1277; /* negabsv1sf2 */

            case E_V2SFmode:
              if (pattern109 (x3, 
E_V2SFmode) != 0
                  || !(
#line 2000 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1278; /* negabsv2sf2 */

            case E_V4SFmode:
              if (pattern109 (x3, 
E_V4SFmode) != 0
                  || !(
#line 2000 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1279; /* negabsv4sf2 */

            case E_V1DFmode:
              if (pattern109 (x3, 
E_V1DFmode) != 0
                  || !
#line 2000 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1280; /* negabsv1df2 */

            case E_V2DFmode:
              if (pattern109 (x3, 
E_V2DFmode) != 0
                  || !
#line 2000 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1281; /* negabsv2df2 */

            case E_V1TFmode:
              if (pattern109 (x3, 
E_V1TFmode) != 0
                  || !(
#line 2000 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1282; /* negabsv1tf2 */

            case E_TFmode:
              if (pattern109 (x3, 
E_TFmode) != 0)
                return -1;
              if ((
#line 2000 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1283; /* negabstf2 */
              if ((
#line 9516 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return 2485; /* *negabstf2_nocc */
              if (pnum_clobbers == NULL
                  || !(
#line 9527 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2491; /* *negabstf2 */

            case E_DImode:
              if (pnum_clobbers == NULL
                  || pattern109 (x3, 
E_DImode) != 0
                  || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2475; /* *negabsdi2 */

            case E_SImode:
              if (pnum_clobbers == NULL
                  || pattern109 (x3, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2476; /* *negabssi2 */

            case E_FPRX2mode:
              if (pattern109 (x3, 
E_FPRX2mode) != 0)
                return -1;
              if ((
#line 9516 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return 2486; /* *negabsfprx22_nocc */
              if (pnum_clobbers == NULL
                  || !(
#line 9527 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2492; /* *negabsfprx22 */

            case E_DFmode:
              if (pattern109 (x3, 
E_DFmode) != 0)
                return -1;
              if (
#line 9516 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
                return 2487; /* *negabsdf2_nocc */
              if (pnum_clobbers == NULL
                  || !
#line 9527 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2493; /* *negabsdf2 */

            case E_SFmode:
              if (pattern109 (x3, 
E_SFmode) != 0)
                return -1;
              if (
#line 9516 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
                return 2488; /* *negabssf2_nocc */
              if (pnum_clobbers == NULL
                  || !
#line 9527 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2494; /* *negabssf2 */

            case E_TDmode:
              if (pattern109 (x3, 
E_TDmode) != 0
                  || !(
#line 9516 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2489; /* *negabstd2_nocc */

            case E_DDmode:
              if (pattern109 (x3, 
E_DDmode) != 0
                  || !(
#line 9516 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2490; /* *negabsdd2_nocc */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pnum_clobbers == NULL
              || GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x9 = XEXP (x5, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 9447 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2470; /* *negabsdi2_sign */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pnum_clobbers == NULL
          || pattern66 (x3, 
E_SImode) != 0
          || !
#line 9099 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2417; /* *negdi2_sign */

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 2972 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1527; /* floatunsv2div2df2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 2972 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 99 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
        return -1;
      return 1528; /* floatunsv4siv4sf2 */

    case E_DFmode:
      switch (pattern67 (x3, 
E_DFmode))
        {
        case 0:
          if (
#line 5667 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            return 2076; /* *floatunsdidf2_z13 */
          if (!(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DFmode != DFmode || DImode != DImode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2082; /* *floatunsdidf2 */

        case 1:
          if (!
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DFmode != DFmode || SImode != DImode)))
            return -1;
          return 2083; /* *floatunssidf2 */

        default:
          return -1;
        }

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          if ((
#line 5667 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return 2077; /* *floatunssisf2_z13 */
          if (!
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || SFmode != DFmode || SImode != DImode)))
            return -1;
          return 2085; /* *floatunssisf2 */

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || SFmode != DFmode || DImode != DImode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2084; /* *floatunsdisf2 */

        default:
          return -1;
        }

    case E_TFmode:
      switch (pattern67 (x3, 
E_TFmode))
        {
        case 0:
          if (!(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TFmode != DFmode || DImode != DImode)) && (
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2078; /* *floatunsditf2 */

        case 1:
          if (!(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TFmode != DFmode || SImode != DImode)) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2079; /* *floatunssitf2 */

        default:
          return -1;
        }

    case E_FPRX2mode:
      switch (pattern67 (x3, 
E_FPRX2mode))
        {
        case 0:
          if (!(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || FPRX2mode != DFmode || DImode != DImode)) && (
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2080; /* *floatunsdifprx22 */

        case 1:
          if (!(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || FPRX2mode != DFmode || SImode != DImode)) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2081; /* *floatunssifprx22 */

        default:
          return -1;
        }

    case E_TDmode:
      switch (pattern67 (x3, 
E_TDmode))
        {
        case 0:
          if (!(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TDmode != DFmode || DImode != DImode)) && (
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2086; /* *floatunsditd2 */

        case 1:
          if (!(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TDmode != DFmode || SImode != DImode)) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2087; /* *floatunssitd2 */

        default:
          return -1;
        }

    case E_DDmode:
      switch (pattern67 (x3, 
E_DDmode))
        {
        case 0:
          if (!(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DDmode != DFmode || DImode != DImode)) && (
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2088; /* *floatunsdidd2 */

        case 1:
          if (!(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DDmode != DFmode || SImode != DImode)) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2089; /* *floatunssidd2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_79 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      x5 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x5))
        {
        case SET:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x7 = XEXP (x5, 1);
          if (!rtx_equal_p (x7, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!const0_operand (operands[1], E_DImode)
                  || !register_operand (operands[2], E_DImode))
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && (
#line 1094 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1739; /* *tstdi_extimm */
              if (!register_operand (operands[0], E_DImode)
                  || !
#line 1136 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_ZARCH && !TARGET_EXTIMM))
                return -1;
              return 1743; /* *tstdi */

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || !const0_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode))
                return -1;
              if (
#line 1094 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM))
                return 1740; /* *tstsi_extimm */
              if (!
#line 1147 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && !TARGET_EXTIMM))
                return -1;
              return 1744; /* *tstsi */

            case E_HImode:
              if (!const0_operand (operands[1], E_HImode)
                  || !register_operand (operands[2], E_HImode))
                return -1;
              if (nonimmediate_operand (operands[0], E_HImode)
                  && 
#line 1197 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return 1749; /* *tsthiCCT */
              if (!s_operand (operands[0], E_HImode)
                  || !
#line 1239 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return -1;
              return 1753; /* *tsthi */

            case E_QImode:
              if (!const0_operand (operands[1], E_QImode)
                  || !register_operand (operands[2], E_QImode))
                return -1;
              if (nonimmediate_operand (operands[0], E_QImode)
                  && 
#line 1197 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return 1750; /* *tstqiCCT */
              if (!s_operand (operands[0], E_QImode)
                  || !
#line 1239 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return -1;
              return 1754; /* *tstqi */

            default:
              return -1;
            }

        case CLOBBER:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && const0_operand (operands[1], E_DImode)
                  && scratch_operand (operands[2], E_DImode)
                  && (
#line 1123 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1741; /* *tstdi_cconly_extimm */
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && const0_operand (operands[1], E_SImode)
                  && scratch_operand (operands[2], E_SImode))
                {
                  if (
#line 1123 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM))
                    return 1742; /* *tstsi_cconly_extimm */
                  if (
#line 1161 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                    return 1745; /* *tstsi_cconly */
                }
              break;

            case E_HImode:
              if (const0_operand (operands[1], E_HImode)
                  && scratch_operand (operands[2], E_HImode))
                {
                  if (nonimmediate_operand (operands[0], E_HImode)
                      && 
#line 1211 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                    return 1751; /* *tsthiCCT_cconly */
                  if (s_operand (operands[0], E_HImode)
                      && 
#line 1252 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                    return 1755; /* *tsthi_cconly */
                }
              break;

            case E_QImode:
              if (s_operand (operands[0], E_QImode)
                  && const0_operand (operands[1], E_QImode)
                  && scratch_operand (operands[2], E_QImode)
                  && 
#line 1252 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return 1756; /* *tstqi_cconly */
              break;

            default:
              break;
            }
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CCZmode
              || GET_MODE (x3) != E_CCZmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || !const0_operand (operands[1], E_TFmode)
                  || !register_operand (operands[2], E_TFmode)
                  || !(
#line 1558 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1775; /* *cmptf_ccz_0 */

            case E_FPRX2mode:
              if (!register_operand (operands[0], E_FPRX2mode)
                  || !const0_operand (operands[1], E_FPRX2mode)
                  || !register_operand (operands[2], E_FPRX2mode)
                  || !(
#line 1558 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1776; /* *cmpfprx2_ccz_0 */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || !const0_operand (operands[1], E_DFmode)
                  || !register_operand (operands[2], E_DFmode)
                  || !
#line 1558 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1777; /* *cmpdf_ccz_0 */

            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || !const0_operand (operands[1], E_SFmode)
                  || !register_operand (operands[2], E_SFmode)
                  || !
#line 1558 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1778; /* *cmpsf_ccz_0 */

            case E_TDmode:
              if (!register_operand (operands[0], E_TDmode)
                  || !const0_operand (operands[1], E_TDmode)
                  || !register_operand (operands[2], E_TDmode)
                  || !(
#line 1558 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 1779; /* *cmptd_ccz_0 */

            case E_DDmode:
              if (!register_operand (operands[0], E_DDmode)
                  || !const0_operand (operands[1], E_DDmode)
                  || !register_operand (operands[2], E_DDmode)
                  || !(
#line 1558 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 1780; /* *cmpdd_ccz_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pattern38 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pattern219 (x3, 
E_TImode) != 0
                  || !
#line 6615 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2238; /* *subti3 */

            case E_DImode:
              if (pattern219 (x3, 
E_DImode) != 0)
                return -1;
              if (
#line 6706 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return 2243; /* *subdi3_31z */
              if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2245; /* *subdi3 */

            case E_SImode:
              if (pattern219 (x3, 
E_SImode) != 0)
                return -1;
              return 2246; /* *subsi3 */

            case E_TFmode:
              if (pattern219 (x3, 
E_TFmode) != 0
                  || !(
#line 6931 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2262; /* subtf3_fpr */

            case E_FPRX2mode:
              if (pattern219 (x3, 
E_FPRX2mode) != 0
                  || !(
#line 6931 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2263; /* subfprx23 */

            case E_DFmode:
              if (pattern219 (x3, 
E_DFmode) != 0
                  || !
#line 6931 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2264; /* subdf3 */

            case E_SFmode:
              if (pattern219 (x3, 
E_SFmode) != 0
                  || !
#line 6931 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2265; /* subsf3 */

            case E_TDmode:
              if (pattern219 (x3, 
E_TDmode) != 0
                  || !(
#line 6931 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2266; /* subtd3 */

            case E_DDmode:
              if (pattern219 (x3, 
E_DDmode) != 0
                  || !(
#line 6931 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2267; /* subdd3 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern248 (x3, 
E_DImode) != 0)
                return -1;
              if (general_operand (operands[2], E_SImode)
                  && 
#line 6654 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2239; /* *subdi3_sign */
              if (!memory_operand (operands[2], E_HImode)
                  || !
#line 6880 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
                return -1;
              return 2259; /* *subdi3_sign */

            case E_SImode:
              if (pattern248 (x3, 
E_SImode) != 0
                  || !memory_operand (operands[2], E_HImode))
                return -1;
              return 2244; /* *subsi3_sign */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!general_operand (operands[2], E_SImode)
              || !
#line 6694 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2242; /* *subdi3_zero */

        default:
          return -1;
        }

    case MINUS:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern249 (x3, 
E_DImode) != 0
              || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2294; /* *subdi3_slb */

        case E_SImode:
          if (pattern249 (x3, 
E_SImode) != 0)
            return -1;
          return 2295; /* *subsi3_slb */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pattern38 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      if (pattern178 (x3) != 0
          || !
#line 9099 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2417; /* *negdi2_sign */

    case REG:
    case SUBREG:
      switch (pattern179 (x3))
        {
        case 0:
          if (
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2422; /* *negdi2 */
          if (!
#line 9141 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2424; /* *negdi2_31 */

        case 1:
          return 2423; /* *negsi2 */

        case 2:
          if (!(
#line 9264 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2439; /* *negtf2 */

        case 3:
          if (!(
#line 9264 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2440; /* *negfprx22 */

        case 4:
          if (!
#line 9264 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2441; /* *negdf2 */

        case 5:
          if (!
#line 9264 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2442; /* *negsf2 */

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 9447 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2470; /* *negabsdi2_sign */

        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern228 (x3, 
E_DImode) != 0
                  || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2475; /* *negabsdi2 */

            case E_SImode:
              if (pattern228 (x3, 
E_SImode) != 0)
                return -1;
              return 2476; /* *negabssi2 */

            case E_TFmode:
              if (pattern228 (x3, 
E_TFmode) != 0
                  || !(
#line 9527 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2491; /* *negabstf2 */

            case E_FPRX2mode:
              if (pattern228 (x3, 
E_FPRX2mode) != 0
                  || !(
#line 9527 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2492; /* *negabsfprx22 */

            case E_DFmode:
              if (pattern228 (x3, 
E_DFmode) != 0
                  || !
#line 9527 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2493; /* *negabsdf2 */

            case E_SFmode:
              if (pattern228 (x3, 
E_SFmode) != 0
                  || !
#line 9527 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2494; /* *negabssf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 1)
    return -1;
  switch (GET_MODE (x3))
    {
    case E_DImode:
      if (!(
#line 11045 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return -1;
      return 2578; /* *basr_r_via_thunk */

    case E_SImode:
      if (!(
#line 11045 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      return 2579; /* *basr_r_via_thunk */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case VEC_SELECT:
      if (GET_MODE (x3) != E_V8HImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 8)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x7 = XVECEXP (x4, 0, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x8 = XVECEXP (x4, 0, 3);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x9 = XVECEXP (x4, 0, 4);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x10 = XVECEXP (x4, 0, 5);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x11 = XVECEXP (x4, 0, 6);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x12 = XVECEXP (x4, 0, 7);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER
          || pattern266 (x1) != 0
          || !
#line 1038 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 679; /* eltswapv8hi */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 4
          || XINT (x3, 1) != 31)
        return -1;
      x15 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x15) != MEM
          || GET_MODE (x15) != E_BLKmode)
        return -1;
      x16 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 0
          || GET_MODE (x16) != E_SImode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER)
        return -1;
      x17 = XEXP (x14, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 33
          || GET_MODE (x17) != E_CCmode)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      x19 = XVECEXP (x3, 0, 0);
      operands[2] = x19;
      x20 = XEXP (x15, 0);
      operands[3] = x20;
      x21 = XVECEXP (x3, 0, 3);
      operands[4] = x21;
      if (!immediate_operand (operands[4], E_VOIDmode))
        return -1;
      x22 = XEXP (x13, 0);
      operands[1] = x22;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern291 (x3, 
E_DImode) != 0
              || !
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          return 1880; /* *strlendi */

        case E_SImode:
          if (pattern291 (x3, 
E_SImode) != 0
              || !
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          return 1881; /* *strlensi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x18 = XEXP (x2, 0);
      switch (GET_CODE (x18))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x18;
          operands[1] = x3;
          x13 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x13))
            {
            case USE:
              if (pnum_clobbers == NULL)
                return -1;
              x14 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x14) != USE
                  || !memory_operand (operands[0], E_BLKmode)
                  || !memory_operand (operands[1], E_BLKmode))
                return -1;
              x22 = XEXP (x13, 0);
              operands[2] = x22;
              if (!nonmemory_operand (operands[2], E_VOIDmode))
                return -1;
              x17 = XEXP (x14, 0);
              operands[3] = x17;
              if (!immediate_operand (operands[3], E_VOIDmode))
                return -1;
              if ((
#line 3590 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1886; /* *cpymem_short */
                }
              if (!(
#line 3590 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1887; /* *cpymem_short */

            case SET:
              x23 = XEXP (x13, 1);
              if (pattern152 (x23, 
E_TImode, 
9, 
UNSPEC_VOLATILE, 
3) != 0)
                return -1;
              x14 = XVECEXP (x1, 0, 2);
              if (pattern180 (x14) != 0
                  || !register_operand (operands[0], E_TImode)
                  || !nonsym_memory_operand (operands[1], E_TImode))
                return -1;
              x24 = XVECEXP (x23, 0, 1);
              operands[2] = x24;
              if (!register_operand (operands[2], E_TImode))
                return -1;
              x25 = XVECEXP (x23, 0, 2);
              operands[3] = x25;
              if (!register_operand (operands[3], E_TImode))
                return -1;
              x26 = XVECEXP (x23, 0, 0);
              if (!rtx_equal_p (x26, operands[1]))
                return -1;
              x22 = XEXP (x13, 0);
              if (!rtx_equal_p (x22, operands[1]))
                return -1;
              x27 = XEXP (x14, 1);
              x28 = XEXP (x27, 0);
              if (!rtx_equal_p (x28, operands[1]))
                return -1;
              x29 = XEXP (x27, 1);
              if (!rtx_equal_p (x29, operands[2])
                  || !
#line 11348 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                return -1;
              return 2591; /* *atomic_compare_and_swapti_1 */

            default:
              return -1;
            }

        case PC:
          x13 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x13) != USE)
            return -1;
          x22 = XEXP (x13, 0);
          if (GET_CODE (x22) != LABEL_REF)
            return -1;
          x14 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x14) != CLOBBER)
            return -1;
          x17 = XEXP (x14, 0);
          if (GET_CODE (x17) != REG
              || REGNO (x17) != 1)
            return -1;
          operands[0] = x3;
          x30 = XEXP (x22, 0);
          operands[1] = x30;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x17) != E_DImode
                  || !(
#line 10587 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 2554; /* casesi_jump_via_thunkdi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x17) != E_SImode
                  || !(
#line 10587 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 2555; /* casesi_jump_via_thunksi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 0L)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != USE)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x22 = XEXP (x13, 0);
      operands[1] = x22;
      x14 = XVECEXP (x1, 0, 2);
      switch (GET_CODE (x14))
        {
        case USE:
          if (pnum_clobbers == NULL
              || !nonmemory_operand (operands[1], E_VOIDmode))
            return -1;
          x17 = XEXP (x14, 0);
          operands[2] = x17;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          if ((
#line 3845 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 2;
              return 1900; /* *clrmem_short */
            }
          if (!(
#line 3845 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 1901; /* *clrmem_short */

        case CLOBBER:
          x17 = XEXP (x14, 0);
          if (GET_CODE (x17) != REG
              || REGNO (x17) != 33
              || GET_MODE (x17) != E_CCmode
              || !const_int_operand (operands[1], E_VOIDmode)
              || !
#line 9001 "../../gcc/config/s390/s390.md"
(INTVAL (operands[1]) >= 1 && INTVAL (operands[1]) <= 256))
            return -1;
          return 2409; /* *xc_zero */

        default:
          return -1;
        }

    case COMPARE:
      if (pnum_clobbers == NULL
          || pattern73 (x1) != 0)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      x22 = XEXP (x13, 0);
      operands[2] = x22;
      if (!nonmemory_operand (operands[2], E_VOIDmode))
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      x17 = XEXP (x14, 0);
      operands[3] = x17;
      if (!immediate_operand (operands[3], E_VOIDmode))
        return -1;
      if ((
#line 4039 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 1908; /* *cmpmem_short */
        }
      if (!(
#line 4039 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1909; /* *cmpmem_short */

    case UNSIGNED_FIX:
      if (pattern42 (x1) != 0)
        return -1;
      switch (pattern150 (x1))
        {
        case 0:
          if (
#line 5517 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            return 2038; /* *fixuns_truncdfdi2_z13 */
          if (!(
#line 5532 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2044; /* *fixuns_truncdfdi2_z196 */

        case 1:
          if (!(
#line 5532 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2040; /* *fixuns_trunctfdi2_z196 */

        case 2:
          if (!(
#line 5532 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2042; /* *fixuns_truncfprx2di2_z196 */

        case 3:
          if (!(
#line 5532 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2046; /* *fixuns_truncsfdi2_z196 */

        case 4:
          if (!(
#line 5532 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TDmode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2048; /* *fixuns_trunctddi2_z196 */

        case 5:
          if (!(
#line 5532 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DDmode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2050; /* *fixuns_truncdddi2_z196 */

        case 6:
          if (!(
#line 5517 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return -1;
          return 2039; /* *fixuns_truncsfsi2_z13 */

        case 7:
          if (!
#line 5532 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          return 2047; /* *fixuns_truncsfsi2_z196 */

        case 8:
          if (!(
#line 5532 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2041; /* *fixuns_trunctfsi2_z196 */

        case 9:
          if (!(
#line 5532 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2043; /* *fixuns_truncfprx2si2_z196 */

        case 10:
          if (!
#line 5532 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          return 2045; /* *fixuns_truncdfsi2_z196 */

        case 11:
          if (!(
#line 5532 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TDmode != DFmode)) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2049; /* *fixuns_trunctdsi2_z196 */

        case 12:
          if (!(
#line 5532 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DDmode != DFmode)) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2051; /* *fixuns_truncddsi2_z196 */

        default:
          return -1;
        }

    case FIX:
      if (pattern42 (x1) != 0)
        return -1;
      switch (pattern151 (x1))
        {
        case 0:
          if (
#line 5555 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            return 2052; /* *fix_truncdfdi2_bfp_z13 */
          if (!(
#line 5568 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2058; /* *fix_truncdfdi2_bfp */

        case 1:
          if (!(
#line 5568 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2054; /* *fix_trunctfdi2_bfp */

        case 2:
          if (!(
#line 5568 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2056; /* *fix_truncfprx2di2_bfp */

        case 3:
          if (!(
#line 5568 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2060; /* *fix_truncsfdi2_bfp */

        case 4:
          if (!
#line 5602 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          return 2062; /* fix_trunctddi2_dfp */

        case 5:
          if (!
#line 5602 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          return 2063; /* fix_truncdddi2_dfp */

        case 6:
          if ((
#line 5555 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return 2053; /* *fix_truncsfsi2_bfp_z13 */
          if (!
#line 5568 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          return 2061; /* *fix_truncsfsi2_bfp */

        case 7:
          if (!(
#line 5568 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2055; /* *fix_trunctfsi2_bfp */

        case 8:
          if (!(
#line 5568 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2057; /* *fix_truncfprx2si2_bfp */

        case 9:
          if (!
#line 5568 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          return 2059; /* *fix_truncdfsi2_bfp */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      if (GET_MODE (x3) != E_DDmode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != UNSPEC
          || XVECLEN (x13, 0) != 1
          || XINT (x13, 1) != 0
          || GET_MODE (x13) != E_DImode)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      if (!register_operand (operands[0], E_DDmode))
        return -1;
      x31 = XEXP (x3, 0);
      operands[1] = x31;
      if (!register_operand (operands[1], E_TDmode))
        return -1;
      x32 = XVECEXP (x13, 0, 0);
      operands[2] = x32;
      if (!const_mask_operand (operands[2], E_DImode))
        return -1;
      x17 = XEXP (x14, 0);
      operands[3] = x17;
      if (!scratch_operand (operands[3], E_TDmode)
          || !
#line 5738 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
        return -1;
      return 2093; /* *trunctddd2 */

    case AND:
      if (pattern43 (x1) != 0
          || !
#line 8261 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 2361; /* *nc */

    case IOR:
      if (pattern43 (x1) != 0
          || !
#line 8671 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 2399; /* *oc */

    case XOR:
      if (pattern43 (x1) != 0
          || !
#line 8944 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 2408; /* *xc */

    case IF_THEN_ELSE:
      x31 = XEXP (x3, 0);
      if (!s390_brx_operator (x31, E_VOIDmode))
        return -1;
      operands[6] = x31;
      x33 = XEXP (x31, 0);
      if (GET_CODE (x33) != PLUS)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != LABEL_REF)
        return -1;
      x34 = XEXP (x3, 2);
      if (GET_CODE (x34) != PC)
        return -1;
      x18 = XEXP (x2, 0);
      if (GET_CODE (x18) != PC)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != SET)
        return -1;
      x23 = XEXP (x13, 1);
      if (GET_CODE (x23) != PLUS)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER)
        return -1;
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2533; /* *brx_stage1_di */

        case 1:
          return 2534; /* *brx_stage1_si */

        default:
          return -1;
        }

    case CALL:
      x31 = XEXP (x3, 0);
      if (GET_CODE (x31) != MEM
          || GET_MODE (x31) != E_QImode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      x33 = XEXP (x31, 0);
      operands[1] = x33;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x22 = XEXP (x13, 0);
      operands[3] = x22;
      if (!register_operand (operands[3], E_VOIDmode))
        return -1;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          res = recog_110 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CONST:
        case SYMBOL_REF:
          if (bras_sym_operand (operands[1], E_VOIDmode))
            {
              x14 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x14) == USE)
                {
                  x17 = XEXP (x14, 0);
                  operands[4] = x17;
                  if (
#line 11115 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)
   && TARGET_SMALL_EXEC
   && GET_MODE (operands[3]) == Pmode))
                    return 2583; /* *bras_tls */
                  if (
#line 11129 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)

   && GET_MODE (operands[3]) == Pmode))
                    return 2584; /* *brasl_tls */
                }
            }
          break;

        default:
          break;
        }
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != USE
          || !address_operand (operands[1], E_VOIDmode))
        return -1;
      x17 = XEXP (x14, 0);
      operands[4] = x17;
      if (!
#line 11144 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn) && GET_MODE (operands[3]) == Pmode))
        return -1;
      return 2585; /* *basr_tls */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          if (peep2_current_count >= 2)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (register_operand (operands[0], E_DImode))
                    {
                      operands[2] = x3;
                      x4 = PATTERN (peep2_next_insn (1));
                      if (pattern127 (x4, 
E_DImode) == 0
                          && (
#line 1108 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (peep2_next_insn (1), CCSmode) && TARGET_EXTIMM
   && GENERAL_REG_P (operands[0])
   && satisfies_constraint_T (operands[2])
   && !contains_constant_pool_address_p (operands[2])) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_1 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      operands[1] = x3;
                      if (pattern128 (x4, 
E_DImode) == 0
                          && 
#line 2334 "../../gcc/config/s390/s390.md"
(TARGET_64BIT
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && preferred_la_operand_p (operands[1], operands[2])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_11 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case E_SImode:
                  if (register_operand (operands[0], E_SImode))
                    {
                      operands[2] = x3;
                      x4 = PATTERN (peep2_next_insn (1));
                      if (pattern127 (x4, 
E_SImode) == 0
                          && 
#line 1108 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (peep2_next_insn (1), CCSmode) && TARGET_EXTIMM
   && GENERAL_REG_P (operands[0])
   && satisfies_constraint_T (operands[2])
   && !contains_constant_pool_address_p (operands[2])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_2 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      operands[1] = x3;
                      if (pattern128 (x4, 
E_SImode) == 0
                          && 
#line 2561 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && preferred_la_operand_p (operands[1], operands[2])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_15 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x3) == MEM)
            {
              x5 = XEXP (x3, 0);
              operands[1] = x5;
              if (address_operand (operands[1], E_VOIDmode))
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_DImode:
                      if (register_operand (operands[0], E_DImode)
                          && GET_MODE (x3) == E_DImode
                          && 
#line 2295 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && !FP_REG_P (operands[0])
   && GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == DImode
   && legitimate_reload_constant_p (get_pool_constant (operands[1]))))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_9 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    case E_SImode:
                      if (register_operand (operands[0], E_SImode)
                          && GET_MODE (x3) == E_SImode
                          && 
#line 2523 "../../gcc/config/s390/s390.md"
(!FP_REG_P (operands[0])
   && GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == SImode
   && legitimate_reload_constant_p (get_pool_constant (operands[1]))))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_13 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    case E_HImode:
                      if (register_operand (operands[0], E_HImode)
                          && GET_MODE (x3) == E_HImode
                          && 
#line 2666 "../../gcc/config/s390/s390.md"
(GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == HImode
   && GET_CODE (get_pool_constant (operands[1])) == CONST_INT))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_16 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    case E_QImode:
                      if (nonimmediate_operand (operands[0], E_QImode)
                          && GET_MODE (x3) == E_QImode
                          && 
#line 2731 "../../gcc/config/s390/s390.md"
(GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == QImode
   && GET_CODE (get_pool_constant (operands[1])) == CONST_INT))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_17 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    default:
                      break;
                    }
                }
            }
          operands[1] = x3;
          if (!memory_operand (operands[1], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || !
#line 2346 "../../gcc/config/s390/s390.md"
(TARGET_64BIT
   && TARGET_EXTIMM
   && GENERAL_REG_P (operands[0])
   && s390_const_int_pool_entry_p (operands[1], nullptr)
   && peep2_reg_dead_p (1, gen_rtx_REG (CCmode, CC_REGNUM))))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_12 (insn, operands);

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          if (peep2_current_count < 2)
            return NULL;
          operands[1] = x3;
          x4 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x4) != SET)
            return NULL;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != COMPARE
              || GET_MODE (x6) != E_CCZmode)
            return NULL;
          x7 = XEXP (x4, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 33
              || GET_MODE (x7) != E_CCZmode)
            return NULL;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          x9 = XEXP (x6, 1);
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (pattern242 (
E_TFmode) != 0
                  || !(
#line 1541 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_3 (insn, operands);

            case E_FPRX2mode:
              if (pattern242 (
E_FPRX2mode) != 0
                  || !(
#line 1541 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_4 (insn, operands);

            case E_DFmode:
              if (pattern242 (
E_DFmode) != 0
                  || !
#line 1541 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_5 (insn, operands);

            case E_SFmode:
              if (pattern242 (
E_SFmode) != 0
                  || !
#line 1541 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_6 (insn, operands);

            case E_TDmode:
              if (pattern242 (
E_TDmode) != 0
                  || !(
#line 1541 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_7 (insn, operands);

            case E_DDmode:
              if (pattern242 (
E_DDmode) != 0
                  || !(
#line 1541 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_8 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x10 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x10) != SET)
            return NULL;
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          x12 = XEXP (x10, 1);
          operands[1] = x12;
          x13 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x13))
            {
            case CLOBBER:
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != REG
                  || REGNO (x14) != 33
                  || GET_MODE (x14) != E_CCmode
                  || !address_operand (operands[1], E_QImode))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !
#line 2321 "../../gcc/config/s390/s390.md"
(TARGET_64BIT
   && preferred_la_operand_p (operands[1], const0_rtx)))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_10 (insn, operands);

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !
#line 2548 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT
   && preferred_la_operand_p (operands[1], const0_rtx)))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_14 (insn, operands);

                default:
                  return NULL;
                }

            case USE:
              if (peep2_current_count >= 2)
                {
                  res = peephole2_1 (x1, insn, pmatch_len_);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!plus16_Q_operand (operands[0], E_BLKmode)
                  || !plus16_Q_operand (operands[1], E_BLKmode))
                return NULL;
              x14 = XEXP (x13, 0);
              operands[2] = x14;
              if (!const_int_operand (operands[2], E_VOIDmode)
                  || !
#line 3157 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) > 16 && INTVAL (operands[2]) <= 32))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_19 (insn, operands);

            default:
              return NULL;
            }

        case 3:
          if (peep2_current_count < 2)
            return NULL;
          x10 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x10) != SET)
            return NULL;
          x13 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x13) != USE)
            return NULL;
          x15 = XVECEXP (x1, 0, 2);
          if (pattern41 (x15) != 0)
            return NULL;
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          if (!memory_operand (operands[0], E_BLKmode))
            return NULL;
          x14 = XEXP (x13, 0);
          if (!const_int_operand (x14, E_VOIDmode))
            return NULL;
          x4 = PATTERN (peep2_next_insn (1));
          if (pattern197 (x4, 
3) != 0)
            return NULL;
          x16 = XVECEXP (x4, 0, 2);
          if (GET_CODE (x16) != CLOBBER)
            return NULL;
          x17 = XEXP (x16, 0);
          if (GET_CODE (x17) != REG
              || REGNO (x17) != 33
              || GET_MODE (x17) != E_CCmode)
            return NULL;
          x18 = XVECEXP (x4, 0, 0);
          x19 = XEXP (x18, 0);
          if (!memory_operand (x19, E_BLKmode))
            return NULL;
          x20 = XVECEXP (x4, 0, 1);
          x21 = XEXP (x20, 0);
          if (!const_int_operand (x21, E_VOIDmode))
            return NULL;
          x12 = XEXP (x10, 1);
          switch (GET_CODE (x12))
            {
            case AND:
              if (pattern293 (x1, 
AND) != 0
                  || !
#line 8297 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_20 (insn, operands);

            case IOR:
              if (pattern293 (x1, 
IOR) != 0
                  || !
#line 8707 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_21 (insn, operands);

            case XOR:
              if (pattern293 (x1, 
XOR) != 0
                  || !
#line 8979 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_22 (insn, operands);

            case CONST_INT:
              if (XWINT (x12, 0) != 0L)
                return NULL;
              operands[1] = x14;
              x22 = XEXP (x18, 1);
              if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              operands[2] = x19;
              operands[3] = x21;
              if (!
#line 9017 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[2], operands[1])
   && INTVAL (operands[1]) + INTVAL (operands[3]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_23 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
