/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern0 (x3, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0)
        return -1;
      return 14;

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern22 (x3, 
E_V16QImode); /* [-1, 2] */

    case E_V8HImode:
      res = pattern22 (x3, 
E_V8HImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V4SImode:
      res = pattern22 (x3, 
E_V4SImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    case E_V2DImode:
      res = pattern22 (x3, 
E_V2DImode);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    case E_V1TImode:
      res = pattern22 (x3, 
E_V1TImode);
      if (res >= 0)
        return res + 12; /* [12, 14] */
      return -1;

    case E_TImode:
      res = pattern22 (x3, 
E_TImode);
      if (res >= 0)
        return res + 15; /* [15, 17] */
      return -1;

    case E_V4SFmode:
      res = pattern22 (x3, 
E_V4SFmode);
      if (res >= 0)
        return res + 18; /* [18, 20] */
      return -1;

    case E_V2DFmode:
      res = pattern22 (x3, 
E_V2DFmode);
      if (res >= 0)
        return res + 21; /* [21, 23] */
      return -1;

    case E_V1TFmode:
      res = pattern22 (x3, 
E_V1TFmode);
      if (res >= 0)
        return res + 24; /* [24, 26] */
      return -1;

    case E_TFmode:
      res = pattern22 (x3, 
E_TFmode);
      if (res >= 0)
        return res + 27; /* [27, 29] */
      return -1;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_operand (operands[1], E_QImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!nonzero_shift_count_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern51 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern51 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern51 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern51 (x1, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern51 (x1, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern51 (x1, 
E_TImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern60 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode
      || !nonimmediate_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern85 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  return 0;
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern95 (x5); /* [-1, 1] */
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  return 0;
}

int
pattern115 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !contiguous_bitmask_nowrap_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (maybe_ne (SUBREG_BYTE (x4), 4)
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTRACT
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 33
      || GET_MODE (x8) != E_CCmode
      || !nonimmediate_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x9 = XEXP (x5, 0);
  operands[1] = x9;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x10 = XEXP (x5, 2);
  operands[2] = x10;
  if (!immediate_operand (operands[2], E_DImode))
    return -1;
  x11 = XEXP (x3, 1);
  operands[3] = x11;
  if (!nonimmediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern134 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (x1))
        {
        case E_DImode:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode))
            return -1;
          return 0;

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      switch (GET_MODE (x1))
        {
        case E_DImode:
          if (pattern133 (x1, 
E_DImode) != 0)
            return -1;
          return 2;

        case E_SImode:
          if (pattern133 (x1, 
E_SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern149 (x1); /* [-1, 5] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_DImode:
              if (!immediate_operand (operands[2], E_DImode))
                return -1;
              return 6;

            case E_SImode:
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              return 7;

            default:
              return -1;
            }

        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 8;

        case E_FPRX2mode:
          if (!register_operand (operands[1], E_FPRX2mode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 9;

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 10;

        case E_TDmode:
          if (!register_operand (operands[1], E_TDmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 11;

        case E_DDmode:
          if (!register_operand (operands[1], E_DDmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 12;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern177 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != i1)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_TFmode:
          return pattern176 (x3, 
E_TFmode); /* [-1, 0] */

        case E_FPRX2mode:
          if (pattern176 (x3, 
E_FPRX2mode) != 0)
            return -1;
          return 1;

        case E_DFmode:
          if (pattern176 (x3, 
E_DFmode) != 0)
            return -1;
          return 2;

        case E_SFmode:
          if (pattern176 (x3, 
E_SFmode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CLOBBER:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || !const0_operand (operands[2], E_TFmode)
              || !scratch_operand (operands[0], E_TFmode))
            return -1;
          return 4;

        case E_FPRX2mode:
          if (!register_operand (operands[1], E_FPRX2mode)
              || !const0_operand (operands[2], E_FPRX2mode)
              || !scratch_operand (operands[0], E_FPRX2mode))
            return -1;
          return 5;

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !const0_operand (operands[2], E_DFmode)
              || !scratch_operand (operands[0], E_DFmode))
            return -1;
          return 6;

        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !const0_operand (operands[2], E_SFmode)
              || !scratch_operand (operands[0], E_SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern204 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern217 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern217 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[0] = x10;
  x11 = XVECEXP (x1, 0, 1);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  x13 = XVECEXP (x1, 0, 2);
  x14 = XEXP (x13, 0);
  operands[5] = x14;
  x15 = XEXP (x11, 1);
  x16 = XEXP (x15, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  x17 = XEXP (x15, 1);
  if (!rtx_equal_p (x17, operands[2]))
    return -1;
  switch (GET_MODE (x5))
    {
    case E_DImode:
      return pattern229 (x15, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern229 (x15, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern249 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !s390_slb_comparison (operands[3], i1))
    return -1;
  return 0;
}

int
pattern257 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern267 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern275 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern282 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern290 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern299 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 9);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i2)
    return -1;
  x8 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i1)
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1199; /* vec_widen_smult_odd_v1qi */

    case 1:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1200; /* vec_widen_smult_odd_v2qi */

    case 2:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1201; /* vec_widen_smult_odd_v4qi */

    case 3:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1202; /* vec_widen_smult_odd_v8qi */

    case 4:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1203; /* vec_widen_smult_odd_v16qi */

    case 5:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1204; /* vec_widen_smult_odd_v1hi */

    case 6:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1205; /* vec_widen_smult_odd_v2hi */

    case 7:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1206; /* vec_widen_smult_odd_v4hi */

    case 8:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1207; /* vec_widen_smult_odd_v8hi */

    case 9:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1208; /* vec_widen_smult_odd_v1si */

    case 10:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1209; /* vec_widen_smult_odd_v2si */

    case 11:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1210; /* vec_widen_smult_odd_v4si */

    case 12:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1211; /* vec_widen_smult_odd_v1di */

    case 13:
      if (!(
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 71 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 1212; /* vec_widen_smult_odd_v2di */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  if (!const_mask_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !(
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 396; /* vec_fpintv1sf */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !(
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 397; /* vec_fpintv2sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 398; /* vec_fpintv4sf */

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x2) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 399; /* vec_fpintv1df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 400; /* vec_fpintv2df */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x2) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode)
          || !(
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 401; /* vec_fpintv1tf */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x2) != E_TFmode
          || !register_operand (operands[1], E_TFmode)
          || !(
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 402; /* vec_fpinttf */

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      res = recog_24 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (!general_operand (x3, E_DImode))
            return -1;
          operands[1] = x3;
          operands[0] = x4;
          if (nonimmediate_operand (operands[0], E_DImode))
            {
              if (
#line 1267 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCTmode) && TARGET_ZARCH))
                return 1757; /* *cmpdi_cct */
              if ((
#line 1355 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1764; /* *cmpdi_ccs */
              if (
#line 1420 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode) && TARGET_ZARCH))
                return 1770; /* *cmpdi_ccu */
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x3;
          operands[1] = x4;
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 6865 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2257; /* *subdi3_cconly2 */

        case E_SImode:
          if (!general_operand (x3, E_SImode))
            return -1;
          operands[1] = x3;
          operands[0] = x4;
          if (nonimmediate_operand (operands[0], E_SImode))
            {
              if (
#line 1281 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCTmode)))
                return 1758; /* *cmpsi_cct */
              if (
#line 1355 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return 1765; /* *cmpsi_ccs */
              if (
#line 1439 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)))
                return 1771; /* *cmpsi_ccu */
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x3;
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 6865 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)))
            return -1;
          *pnum_clobbers = 1;
          return 2258; /* *subsi3_cconly2 */

        case E_HImode:
          operands[0] = x4;
          if (!nonimmediate_operand (operands[0], E_HImode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_HImode)
              || !
#line 1459 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && !register_operand (operands[1], HImode)))
            return -1;
          return 1772; /* *cmphi_ccu */

        case E_QImode:
          operands[0] = x4;
          if (!nonimmediate_operand (operands[0], E_QImode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_QImode)
              || !
#line 1475 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && !register_operand (operands[1], QImode)))
            return -1;
          return 1773; /* *cmpqi_ccu */

        case E_TFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_TFmode))
            return -1;
          operands[1] = x3;
          if (general_operand (operands[1], E_TFmode)
              && (
#line 1581 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 1787; /* *cmptf_ccs */
          if (register_operand (operands[1], E_TFmode)
              && 
#line 1596 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_VXE))
            return 1793; /* *cmptf_ccs */
          if (general_operand (operands[1], E_TFmode)
              && (
#line 1607 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 1794; /* *cmptf_ccsfps */
          if (!register_operand (operands[1], E_TFmode)
              || !
#line 1622 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_VXE))
            return -1;
          return 1800; /* *cmptf_ccsfps */

        case E_FPRX2mode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_FPRX2mode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_FPRX2mode))
            return -1;
          if ((
#line 1581 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 1788; /* *cmpfprx2_ccs */
          if (!(
#line 1607 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1795; /* *cmpfprx2_ccsfps */

        case E_DFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_DFmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 1581 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT))
            return 1789; /* *cmpdf_ccs */
          if (!
#line 1607 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 1796; /* *cmpdf_ccsfps */

        case E_SFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_SFmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 1581 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT))
            return 1790; /* *cmpsf_ccs */
          if (!
#line 1607 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 1797; /* *cmpsf_ccsfps */

        case E_TDmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_TDmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_TDmode))
            return -1;
          if ((
#line 1581 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return 1791; /* *cmptd_ccs */
          if (!(
#line 1607 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1798; /* *cmptd_ccsfps */

        case E_DDmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_DDmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_DDmode))
            return -1;
          if ((
#line 1581 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return 1792; /* *cmpdd_ccs */
          if (!(
#line 1607 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1799; /* *cmpdd_ccsfps */

        default:
          return -1;
        }

    case NEG:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[1], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !general_operand (operands[2], E_DImode)
              || !(
#line 6357 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2211; /* *adddi3_cconly2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !general_operand (operands[2], E_SImode)
              || !
#line 6357 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2212; /* *addsi3_cconly2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_25 (x1, insn, pnum_clobbers);

    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x4;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          switch (GET_MODE (x3))
            {
            case E_QImode:
              if (memory_operand (operands[0], E_QImode)
                  && immediate_operand (operands[1], E_QImode)
                  && immediate_operand (operands[2], E_QImode)
                  && 
#line 1016 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], false))))
                return 1733; /* *tmqi_mem */
              break;

            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && immediate_operand (operands[1], E_DImode)
                  && immediate_operand (operands[2], E_DImode)
                  && 
#line 1030 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], true))
   && s390_single_part (operands[1], DImode, HImode, 0) >= 0))
                return 1734; /* *tmdi_reg */
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && immediate_operand (operands[1], E_SImode)
                  && immediate_operand (operands[2], E_SImode)
                  && 
#line 1046 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], true))
   && s390_single_part (operands[1], SImode, HImode, 0) >= 0))
                return 1735; /* *tmsi_reg */
              break;

            default:
              break;
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x4;
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[2] = x5;
          switch (pattern155 (x3))
            {
            case 0:
              if (!
#line 7935 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], DImode, HImode, 0) < 0))
                return -1;
              *pnum_clobbers = 1;
              return 2341; /* *anddi3_cconly */

            case 1:
              if (!
#line 8063 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], SImode, HImode, 0) < 0))
                return -1;
              *pnum_clobbers = 1;
              return 2352; /* *andsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XEXP (x2, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern134 (x3))
            {
            case 0:
              if (!(
#line 8598 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2377; /* *andcdi_cconly */

            case 1:
              if (!
#line 8598 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2379; /* *andcsi_cconly */

            case 2:
              if (!(
#line 8638 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2389; /* *nordi_cconly */

            case 3:
              if (!
#line 8638 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2391; /* *norsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x6 = XEXP (x2, 1);
      operands[0] = x6;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !register_operand (operands[0], E_DImode)
                  || !
#line 1300 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_ZARCH))
                return -1;
              return 1759; /* *cmpdi_ccs_sign */

            case E_HImode:
              if (!memory_operand (operands[1], E_HImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 1340 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1762; /* *cmpdi_ccs_signhi_rl */

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !
#line 1340 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_Z10))
                    return -1;
                  return 1763; /* *cmpdi_ccs_signhi_rl */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_SImode:
          if (!memory_operand (operands[1], E_HImode)
              || !register_operand (operands[0], E_SImode)
              || !
#line 1316 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode)))
            return -1;
          return 1760; /* *cmpsi_ccs_sign */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x2, 1);
      operands[0] = x6;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) == MEM
          && GET_MODE (x4) == E_HImode)
        {
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          switch (GET_MODE (x3))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode))
                {
                  if (larl_operand (operands[1], E_SImode)
                      && 
#line 1378 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10))
                    return 1766; /* *cmpsi_ccu_zerohi_rlsi */
                  if (larl_operand (operands[1], E_DImode)
                      && 
#line 1391 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10))
                    return 1768; /* *cmpsi_ccu_zerohi_rldi */
                }
              break;

            case E_DImode:
              if (larl_operand (operands[1], E_DImode)
                  && register_operand (operands[0], E_DImode)
                  && (
#line 1391 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1767; /* *cmpdi_ccu_zerohi_rldi */
              break;

            default:
              break;
            }
        }
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 1403 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCURmode) && TARGET_ZARCH))
        return -1;
      return 1769; /* *cmpdi_ccu_zero */

    case IOR:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case AND:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != AND
              || GET_MODE (x5) != E_DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!contiguous_bitmask_operand (operands[2], E_DImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          if (!nonimmediate_operand (operands[3], E_DImode))
            return -1;
          x10 = XEXP (x5, 1);
          operands[4] = x10;
          if (!const_int_operand (operands[4], E_DImode)
              || !
#line 4536 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && s390_match_ccmode (insn, CCSmode)
   && INTVAL (operands[2]) == ~INTVAL (operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 1959; /* *insv_z10_noshift_cconly */

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x4;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (pattern155 (x3))
            {
            case 0:
              if (!
#line 8349 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2363; /* *iordi3_cconly */

            case 1:
              if (!
#line 8431 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2366; /* *iorsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          switch (pattern134 (x3))
            {
            case 0:
              if (!(
#line 8598 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2378; /* *orcdi_cconly */

            case 1:
              if (!
#line 8598 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2380; /* *orcsi_cconly */

            case 2:
              if (!(
#line 8638 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2390; /* *nanddi_cconly */

            case 3:
              if (!
#line 8638 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2392; /* *nandsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      return recog_26 (x1, insn, pnum_clobbers);

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x6 = XEXP (x2, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          if (!general_operand (operands[2], E_SImode)
              || !
#line 6682 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2241; /* *subdi3_zero_cconly */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              if (!rtx_equal_p (x6, operands[1]))
                return -1;
              switch (pattern188 (x3))
                {
                case 0:
                  if (!(
#line 6796 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2249; /* *subdi3_borrow_cconly */

                case 1:
                  if (!
#line 6796 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2250; /* *subsi3_borrow_cconly */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  switch (pattern188 (x3))
                    {
                    case 0:
                      if ((
#line 6848 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        {
                          *pnum_clobbers = 1;
                          return 2255; /* *subdi3_cconly */
                        }
                      break;

                    case 1:
                      if (
#line 6848 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                        {
                          *pnum_clobbers = 1;
                          return 2256; /* *subsi3_cconly */
                        }
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x6;
              switch (GET_MODE (x3))
                {
                case E_TFmode:
                  if (!nonimmediate_operand (operands[1], E_TFmode)
                      || !general_operand (operands[2], E_TFmode)
                      || !const0_operand (operands[3], E_TFmode)
                      || !(
#line 6967 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2274; /* *subtf3_cconly */

                case E_FPRX2mode:
                  if (!nonimmediate_operand (operands[1], E_FPRX2mode)
                      || !general_operand (operands[2], E_FPRX2mode)
                      || !const0_operand (operands[3], E_FPRX2mode)
                      || !(
#line 6967 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2275; /* *subfprx23_cconly */

                case E_DFmode:
                  if (!nonimmediate_operand (operands[1], E_DFmode)
                      || !general_operand (operands[2], E_DFmode)
                      || !const0_operand (operands[3], E_DFmode)
                      || !
#line 6967 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2276; /* *subdf3_cconly */

                case E_SFmode:
                  if (!nonimmediate_operand (operands[1], E_SFmode)
                      || !general_operand (operands[2], E_SFmode)
                      || !const0_operand (operands[3], E_SFmode)
                      || !
#line 6967 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2277; /* *subsf3_cconly */

                case E_TDmode:
                  if (!nonimmediate_operand (operands[1], E_TDmode)
                      || !general_operand (operands[2], E_TDmode)
                      || !const0_operand (operands[3], E_TDmode)
                      || !(
#line 6967 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2278; /* *subtd3_cconly */

                case E_DDmode:
                  if (!nonimmediate_operand (operands[1], E_DDmode)
                      || !general_operand (operands[2], E_DDmode)
                      || !const0_operand (operands[3], E_DDmode)
                      || !(
#line 6967 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2279; /* *subdd3_cconly */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (pattern155 (x3))
        {
        case 0:
          if (!
#line 8774 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2401; /* *xordi3_cconly */

        case 1:
          if (!
#line 8841 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2404; /* *xorsi3_cconly */

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != XOR)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode)
              || !(
#line 9052 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2412; /* *nxordi_cconly */

        case E_SImode:
          if (GET_MODE (x4) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode)
              || !
#line 9052 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2413; /* *nxorsi_cconly */

        default:
          return -1;
        }

    case NEG:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x6 = XEXP (x2, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_MODE (x3))
                {
                case E_DImode:
                  if (register_operand (operands[1], E_DImode)
                      && (
#line 9122 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    {
                      *pnum_clobbers = 1;
                      return 2420; /* *negdi2_cconly */
                    }
                  break;

                case E_SImode:
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 9122 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    {
                      *pnum_clobbers = 1;
                      return 2421; /* *negsi2_cconly */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[2] = x6;
          switch (pattern135 (x3))
            {
            case 0:
              if (!(
#line 9243 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2429; /* *negtf2_cconly */

            case 1:
              if (!(
#line 9243 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2430; /* *negfprx22_cconly */

            case 2:
              if (!
#line 9243 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2431; /* *negdf2_cconly */

            case 3:
              if (!
#line 9243 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2432; /* *negsf2_cconly */

            default:
              return -1;
            }

        case ABS:
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          x6 = XEXP (x2, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_MODE (x3))
                {
                case E_DImode:
                  if (GET_MODE (x4) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && (
#line 9470 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    {
                      *pnum_clobbers = 1;
                      return 2473; /* *negabsdi2_cconly */
                    }
                  break;

                case E_SImode:
                  if (GET_MODE (x4) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 9470 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    {
                      *pnum_clobbers = 1;
                      return 2474; /* *negabssi2_cconly */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[2] = x6;
          switch (GET_MODE (x3))
            {
            case E_TFmode:
              if (GET_MODE (x4) != E_TFmode
                  || !register_operand (operands[1], E_TFmode)
                  || !const0_operand (operands[2], E_TFmode)
                  || !(
#line 9507 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2481; /* *negabstf2_cconly */

            case E_FPRX2mode:
              if (GET_MODE (x4) != E_FPRX2mode
                  || !register_operand (operands[1], E_FPRX2mode)
                  || !const0_operand (operands[2], E_FPRX2mode)
                  || !(
#line 9507 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2482; /* *negabsfprx22_cconly */

            case E_DFmode:
              if (GET_MODE (x4) != E_DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !const0_operand (operands[2], E_DFmode)
                  || !
#line 9507 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2483; /* *negabsdf2_cconly */

            case E_SFmode:
              if (GET_MODE (x4) != E_SFmode
                  || !register_operand (operands[1], E_SFmode)
                  || !const0_operand (operands[2], E_SFmode)
                  || !
#line 9507 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2484; /* *negabssf2_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x6 = XEXP (x2, 1);
      if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          switch (GET_MODE (x3))
            {
            case E_DImode:
              if (register_operand (operands[1], E_DImode)
                  && (
#line 9323 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2447; /* *absdi2_cconly */
                }
              break;

            case E_SImode:
              if (register_operand (operands[1], E_SImode)
                  && 
#line 9323 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                {
                  *pnum_clobbers = 1;
                  return 2448; /* *abssi2_cconly */
                }
              break;

            default:
              break;
            }
        }
      operands[2] = x6;
      switch (pattern135 (x3))
        {
        case 0:
          if (!(
#line 9368 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2455; /* *abstf2_cconly */

        case 1:
          if (!(
#line 9368 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2456; /* *absfprx22_cconly */

        case 2:
          if (!
#line 9368 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2457; /* *absdf2_cconly */

        case 3:
          if (!
#line 9368 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2458; /* *abssf2_cconly */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!shift_count_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          if ((
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 9730 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 2511; /* *ashrdi3_31_cconly */
            }
          if (!(
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2514; /* *ashrdi3_cconly */

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2517; /* *ashrsi3_cconly */

        default:
          return -1;
        }

    case POPCOUNT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 12098 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
        return -1;
      *pnum_clobbers = 1;
      return 2635; /* *popcountdi_z15_cconly */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 4:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 3);
      operands[4] = x4;
      switch (XINT (x2, 1))
        {
        case 61:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!memory_operand (operands[3], E_BLKmode)
              || !const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern19 (x2, 
E_V4SImode) != 0
                  || !
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V4SImode)))
                return -1;
              return 1; /* vec_gather_elementv4si */

            case E_V2DImode:
              if (pattern19 (x2, 
E_V2DImode) != 0
                  || !
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V2DImode)))
                return -1;
              return 2; /* vec_gather_elementv2di */

            case E_V2DFmode:
              if (pattern198 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V2DFmode)))
                return -1;
              return 3; /* vec_gather_elementv2df */

            case E_V4SFmode:
              if (pattern198 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 23 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
                return -1;
              return 4; /* vec_gather_elementv4sf */

            default:
              return -1;
            }

        case 96:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_int_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern51 (x2, 
E_V16QImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 203; /* verimv16qi */

            case E_V8HImode:
              if (pattern51 (x2, 
E_V8HImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 204; /* verimv8hi */

            case E_V4SImode:
              if (pattern51 (x2, 
E_V4SImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 205; /* verimv4si */

            case E_V2DImode:
              if (pattern51 (x2, 
E_V2DImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 206; /* verimv2di */

            default:
              return -1;
            }

        case 131:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_V2DImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (!register_operand (operands[2], E_V2DImode))
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x2) != E_V16QImode
                  || !register_operand (operands[3], E_V16QImode)
                  || !
#line 1258 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
                return -1;
              return 357; /* vec_msumv2di */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !register_operand (operands[3], E_TImode)
                  || !
#line 1269 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
                return -1;
              return 358; /* vmslg */

            default:
              return -1;
            }

        case 118:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern51 (x2, 
E_V16QImode) != 0
                  || !
#line 1541 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 383; /* vstrcv16qi */

            case E_V8HImode:
              if (pattern51 (x2, 
E_V8HImode) != 0
                  || !
#line 1541 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 384; /* vstrcv8hi */

            case E_V4SImode:
              if (pattern51 (x2, 
E_V4SImode) != 0
                  || !
#line 1541 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 385; /* vstrcv4si */

            default:
              return -1;
            }

        case 135:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_int_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern51 (x2, 
E_V1QImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1717; /* vevalv1qi */

            case E_V2QImode:
              if (pattern51 (x2, 
E_V2QImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1718; /* vevalv2qi */

            case E_V4QImode:
              if (pattern51 (x2, 
E_V4QImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1719; /* vevalv4qi */

            case E_V8QImode:
              if (pattern51 (x2, 
E_V8QImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1720; /* vevalv8qi */

            case E_V16QImode:
              if (pattern51 (x2, 
E_V16QImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1721; /* vevalv16qi */

            case E_V1HImode:
              if (pattern51 (x2, 
E_V1HImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1722; /* vevalv1hi */

            case E_V2HImode:
              if (pattern51 (x2, 
E_V2HImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1723; /* vevalv2hi */

            case E_V4HImode:
              if (pattern51 (x2, 
E_V4HImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1724; /* vevalv4hi */

            case E_V8HImode:
              if (pattern51 (x2, 
E_V8HImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1725; /* vevalv8hi */

            case E_V1SImode:
              if (pattern51 (x2, 
E_V1SImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1726; /* vevalv1si */

            case E_V2SImode:
              if (pattern51 (x2, 
E_V2SImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1727; /* vevalv2si */

            case E_V4SImode:
              if (pattern51 (x2, 
E_V4SImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1728; /* vevalv4si */

            case E_V1DImode:
              if (pattern51 (x2, 
E_V1DImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1729; /* vevalv1di */

            case E_V2DImode:
              if (pattern51 (x2, 
E_V2DImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1730; /* vevalv2di */

            case E_V1TImode:
              if (pattern51 (x2, 
E_V1TImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1731; /* vevalv1ti */

            case E_TImode:
              if (pattern51 (x2, 
E_TImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1732; /* vevalti */

            default:
              return -1;
            }

        case 31:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 0
              || GET_MODE (x7) != E_SImode)
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          operands[2] = x5;
          x8 = XEXP (x6, 0);
          operands[3] = x8;
          if (!immediate_operand (operands[4], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern251 (x2, 
E_DImode) != 0
                  || !
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 1880; /* *strlendi */

            case E_SImode:
              if (pattern251 (x2, 
E_SImode) != 0
                  || !
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 1881; /* *strlensi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      return recog_17 (x1, insn, pnum_clobbers);

    case 2:
      return recog_16 (x1, insn, pnum_clobbers);

    case 3:
      return recog_18 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0
          || !
#line 1155 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 722; /* divv4si3 */

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0
          || !
#line 1155 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 723; /* divv2di3 */

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0
          || !
#line 1155 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 724; /* divv1ti3 */

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0
          || !
#line 1155 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 725; /* divti3 */

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0
          || !(
#line 1901 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1239; /* divv4sf3 */

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0
          || !
#line 1901 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1240; /* divv2df3 */

    case E_V1TFmode:
      if (pattern0 (x3, 
E_V1TFmode) != 0
          || !(
#line 1901 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1241; /* divv1tf3 */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      if (register_operand (operands[2], E_TFmode)
          && (
#line 1901 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return 1242; /* divtf3_vr */
      if (!general_operand (operands[2], E_TFmode)
          || !(
#line 7881 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 2334; /* divtf3_fpr */

    case E_FPRX2mode:
      if (pattern85 (x3, 
E_FPRX2mode) != 0
          || !(
#line 7881 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 2335; /* divfprx23 */

    case E_DFmode:
      if (pattern85 (x3, 
E_DFmode) != 0
          || !
#line 7881 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2336; /* divdf3 */

    case E_SFmode:
      if (pattern85 (x3, 
E_SFmode) != 0
          || !
#line 7881 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2337; /* divsf3 */

    case E_TDmode:
      if (pattern85 (x3, 
E_TDmode) != 0
          || !(
#line 7881 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 2338; /* divtd3 */

    case E_DDmode:
      if (pattern85 (x3, 
E_DDmode) != 0
          || !(
#line 7881 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 2339; /* divdd3 */

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 2942 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1525; /* floatv2div2df2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 2942 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 99 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
        return -1;
      return 1526; /* floatv4siv4sf2 */

    case E_TFmode:
      switch (pattern67 (x3, 
E_TFmode))
        {
        case 0:
          if (!(
#line 5629 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2064; /* floatditf2_fpr */

        case 1:
          if (!(
#line 5642 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2070; /* floatsitf2_fpr */

        default:
          return -1;
        }

    case E_FPRX2mode:
      switch (pattern67 (x3, 
E_FPRX2mode))
        {
        case 0:
          if (!(
#line 5629 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2065; /* floatdifprx22 */

        case 1:
          if (!(
#line 5642 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2071; /* floatsifprx22 */

        default:
          return -1;
        }

    case E_DFmode:
      switch (pattern67 (x3, 
E_DFmode))
        {
        case 0:
          if (!
#line 5629 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT))
            return -1;
          return 2066; /* floatdidf2 */

        case 1:
          if (!
#line 5642 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2072; /* floatsidf2 */

        default:
          return -1;
        }

    case E_SFmode:
      switch (pattern67 (x3, 
E_SFmode))
        {
        case 0:
          if (!
#line 5629 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT))
            return -1;
          return 2067; /* floatdisf2 */

        case 1:
          if (!
#line 5642 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2073; /* floatsisf2 */

        default:
          return -1;
        }

    case E_TDmode:
      switch (pattern67 (x3, 
E_TDmode))
        {
        case 0:
          if (!(
#line 5629 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2068; /* floatditd2 */

        case 1:
          if (!
#line 5655 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT))
            return -1;
          return 2074; /* floatsitd2 */

        default:
          return -1;
        }

    case E_DDmode:
      switch (pattern67 (x3, 
E_DDmode))
        {
        case 0:
          if (!(
#line 5629 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2069; /* floatdidd2 */

        case 1:
          if (!
#line 5655 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT))
            return -1;
          return 2075; /* floatsidd2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != NEG)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (pattern239 (x1))
        {
        case 0:
          if (!(
#line 9111 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2418; /* *negdi2_cc */

        case 1:
          if (!
#line 9111 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2419; /* *negsi2_cc */

        default:
          return -1;
        }

    case CLOBBER:
      switch (pattern192 (x1))
        {
        case 0:
          if (!(
#line 9122 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2420; /* *negdi2_cconly */

        case 1:
          if (!
#line 9122 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2421; /* *negsi2_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PLUS)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x9 = XEXP (x4, 0);
  operands[1] = x9;
  x10 = XEXP (x3, 1);
  x11 = XEXP (x10, 0);
  operands[0] = x11;
  x12 = XEXP (x6, 0);
  operands[2] = x12;
  x13 = XEXP (x7, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonimmediate_operand (operands[2], E_SImode)
          || GET_MODE (x7) != E_SImode)
        return -1;
      *pnum_clobbers = 2;
      return 2538; /* doloop_si64 */

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonimmediate_operand (operands[2], E_DImode)
          || GET_MODE (x7) != E_DImode
          || !
#line 10251 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 2;
      return 2539; /* doloop_di */

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (SUBREG_BYTE (x4))
    {
    case 0:
      if (GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case ROTATE:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x8 = XEXP (x3, 1);
          operands[3] = x8;
          if (!contiguous_bitmask_operand (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 4375 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1933; /* *risbg_and_subregdi_rotr */
              if (!
#line 4388 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              return 1939; /* *risbg_and_subregdi_rotl */

            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !const_int_operand (operands[2], E_HImode))
                return -1;
              if (
#line 4375 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1935; /* *risbg_and_subregdi_rotr */
              if (!
#line 4388 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              return 1941; /* *risbg_and_subregdi_rotl */

            case E_QImode:
              if (!register_operand (operands[1], E_QImode)
                  || !const_int_operand (operands[2], E_QImode))
                return -1;
              if (
#line 4375 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1937; /* *risbg_and_subregdi_rotr */
              if (!
#line 4388 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              return 1943; /* *risbg_and_subregdi_rotl */

            default:
              return -1;
            }

        case SUBREG:
        case MEM:
          operands[1] = x5;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != CONST_INT
              || XWINT (x8, 0) != 2147483647L
              || !
#line 5173 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2021; /* *llgt_sidi_split */

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      if (!contiguous_bitmask_nowrap_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!nonzero_shift_count_operand (operands[2], E_DImode)
              || !
#line 4598 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          return 1971; /* *trunc_sidi_and_subreg_lshrt_clobbercc */

        case ZERO_EXTRACT:
          x7 = XEXP (x5, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x5, 2);
          operands[2] = x9;
          if (!nonzero_shift_count_operand (operands[2], E_SImode)
              || !
#line 4612 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          return 1973; /* *trunc_sidi_and_subreg_ze_clobbercc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (XINT (x3, 1))
        {
        case 69:
          switch (pattern143 (x1, 
68))
            {
            case 0:
              if (!
#line 312 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 24; /* *vec_packs_ccv8hi */

            case 1:
              if (!
#line 312 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 25; /* *vec_packs_ccv4si */

            case 2:
              if (!
#line 312 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 26; /* *vec_packs_ccv2di */

            default:
              return -1;
            }

        case 72:
          switch (pattern143 (x1, 
71))
            {
            case 0:
              if (!
#line 387 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 30; /* *vec_packsu_ccv8hi */

            case 1:
              if (!
#line 387 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 31; /* *vec_packsu_ccv4si */

            case 2:
              if (!
#line 387 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 32; /* *vec_packsu_ccv2di */

            default:
              return -1;
            }

        case 130:
          if (GET_MODE (x3) != E_CCRAWmode)
            return -1;
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 33
              || GET_MODE (x6) != E_CCRAWmode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER
              || !const_int_operand (operands[2], E_HImode))
            return -1;
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !scratch_operand (operands[0], E_V4SImode)
                  || !(
#line 1927 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 405; /* *vftciv4sf_cconly */

            case E_V2DFmode:
              if (!register_operand (operands[1], E_V2DFmode)
                  || !scratch_operand (operands[0], E_V2DImode)
                  || !
#line 1927 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")))
                return -1;
              return 406; /* *vftciv2df_cconly */

            case E_V1TFmode:
              if (!register_operand (operands[1], E_V1TFmode)
                  || !scratch_operand (operands[0], E_V1TImode)
                  || !(
#line 1927 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 407; /* *vftciv1tf_cconly */

            case E_TFmode:
              if (!register_operand (operands[1], E_TFmode)
                  || !scratch_operand (operands[0], E_TImode)
                  || !(
#line 1927 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 408; /* *vftcitf_cconly */

            default:
              return -1;
            }

        case 129:
          x7 = XVECEXP (x1, 0, 1);
          if (pattern44 (x7, 
130, 
2, 
UNSPEC) != 0)
            return -1;
          x9 = XEXP (x7, 1);
          if (GET_MODE (x9) != E_CCRAWmode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCRAWmode)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!const_int_operand (operands[2], E_HImode))
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XVECEXP (x9, 0, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || !register_operand (operands[1], E_V4SFmode)
                  || !(
#line 1953 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 409; /* vftciv4sf */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x3) != E_V2DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !
#line 1953 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")))
                return -1;
              return 410; /* vftciv2df */

            case E_V1TFmode:
              if (!register_operand (operands[0], E_V1TFmode)
                  || GET_MODE (x3) != E_V1TFmode
                  || !register_operand (operands[1], E_V1TFmode)
                  || !(
#line 1953 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 411; /* vftciv1tf */

            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || GET_MODE (x3) != E_TFmode
                  || !register_operand (operands[1], E_TFmode)
                  || !(
#line 1953 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 412; /* vftcitf */

            default:
              return -1;
            }

        case 1:
          if (pattern38 (x1) != 0
              || !s_operand (operands[1], E_BLKmode)
              || !const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              return 1917; /* *sethighpartsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              if (
#line 4260 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 1918; /* *sethighpartdi_64 */
              if (!
#line 4270 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              return 1919; /* *sethighpartdi_31 */

            default:
              return -1;
            }

        case 46:
          if (pattern102 (x1) != 0
              || !address_operand (operands[1], E_VOIDmode)
              || !immediate_operand (operands[2], E_SImode)
              || !
#line 12550 "../../gcc/config/s390/s390.md"
(TARGET_Z13))
            return -1;
          return 2660; /* lcbb */

        default:
          return -1;
        }

    case 3:
      if (pattern68 (x1, 
3) != 0
          || !const_mask_operand (operands[3], E_QImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x7, 1);
      x10 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = XVECEXP (x9, 0, 2);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 110:
          switch (pattern281 (x1, 
111))
            {
            case 0:
              if (!
#line 1311 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 362; /* *vfaesv16qi */

            case 1:
              if (!
#line 1311 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 363; /* *vfaesv8hi */

            case 2:
              if (!
#line 1311 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 364; /* *vfaesv4si */

            default:
              return -1;
            }

        case 112:
          switch (pattern281 (x1, 
113))
            {
            case 0:
              if (!
#line 2444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1407; /* vec_vfeesv16qi */

            case 1:
              if (!
#line 2444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1408; /* vec_vfeesv8hi */

            case 2:
              if (!
#line 2444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1409; /* vec_vfeesv4si */

            default:
              return -1;
            }

        case 114:
          switch (pattern281 (x1, 
115))
            {
            case 0:
              if (!
#line 2470 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1410; /* vec_vfenesv16qi */

            case 1:
              if (!
#line 2470 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1411; /* vec_vfenesv8hi */

            case 2:
              if (!
#line 2470 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1412; /* vec_vfenesv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 116:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x9 = XEXP (x7, 1);
          if (pattern152 (x9, 
E_CCRAWmode, 
117, 
UNSPEC, 
1) != 0)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCRAWmode)
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x3) != E_V16QImode
                  || !register_operand (operands[1], E_V16QImode)
                  || !
#line 1513 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 380; /* *vistrsv16qi */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x3) != E_V8HImode
                  || !register_operand (operands[1], E_V8HImode)
                  || !
#line 1513 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 381; /* *vistrsv8hi */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x3) != E_V4SImode
                  || !register_operand (operands[1], E_V4SImode)
                  || !
#line 1513 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 382; /* *vistrsv4si */

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern89 (x7) != 0
              || !register_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_CCUmode))
            return -1;
          return 1913; /* cmpint */

        case 37:
          x7 = XVECEXP (x1, 0, 1);
          if (pattern89 (x7) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !(
#line 12116 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 795 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2637; /* *popcountdi_z196 */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 12116 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                return -1;
              return 2638; /* *popcountsi_z196 */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !register_operand (operands[1], E_HImode)
                  || !
#line 12116 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                return -1;
              return 2639; /* *popcounthi_z196 */

            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode
                  || !register_operand (operands[1], E_QImode)
                  || !
#line 12116 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                return -1;
              return 2640; /* *popcountqi_z196 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      if (pattern68 (x1, 
4) != 0)
        return -1;
      x13 = XVECEXP (x3, 0, 3);
      operands[4] = x13;
      if (!const_mask_operand (operands[4], E_QImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x7, 1);
      x10 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = XVECEXP (x9, 0, 2);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      x14 = XVECEXP (x9, 0, 3);
      if (!rtx_equal_p (x14, operands[4]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 118:
          if (XINT (x9, 1) != 119)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern295 (x3, 
E_V16QImode) != 0
                  || !
#line 1570 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 386; /* *vstrcsv16qi */

            case E_V8HImode:
              if (pattern295 (x3, 
E_V8HImode) != 0
                  || !
#line 1570 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 387; /* *vstrcsv8hi */

            case E_V4SImode:
              if (pattern295 (x3, 
E_V4SImode) != 0
                  || !
#line 1570 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 388; /* *vstrcsv4si */

            default:
              return -1;
            }

        case 120:
          if (GET_MODE (x3) != E_V16QImode
              || XINT (x9, 1) != 121
              || !register_operand (operands[0], E_V16QImode)
              || !register_operand (operands[3], E_V16QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !register_operand (operands[2], E_V16QImode)
                  || !
#line 1691 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 389; /* vec_vstrsv16qi */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !register_operand (operands[2], E_V8HImode)
                  || !
#line 1691 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 390; /* vec_vstrsv8hi */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !register_operand (operands[2], E_V4SImode)
                  || !
#line 1691 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 391; /* vec_vstrsv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (register_operand (operands[0], E_V16QImode)
          && register_operand (operands[1], E_V16QImode)
          && 
#line 293 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_1 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V16QImode)
          && general_operand (operands[1], E_V16QImode))
        {
          if (
#line 313 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V16QImode, 0)))
            return gen_split_10 (insn, operands);
          if (
#line 327 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V16QImode, 1)))
            return gen_split_19 (insn, operands);
        }
      if (!register_operand (operands[0], E_V16QImode)
          || !memory_operand (operands[1], E_V16QImode)
          || !
#line 347 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_28 (insn, operands);

    case E_V8HImode:
      if (register_operand (operands[0], E_V8HImode)
          && register_operand (operands[1], E_V8HImode)
          && 
#line 293 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_2 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V8HImode)
          && general_operand (operands[1], E_V8HImode))
        {
          if (
#line 313 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V8HImode, 0)))
            return gen_split_11 (insn, operands);
          if (
#line 327 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V8HImode, 1)))
            return gen_split_20 (insn, operands);
        }
      if (!register_operand (operands[0], E_V8HImode)
          || !memory_operand (operands[1], E_V8HImode)
          || !
#line 347 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_29 (insn, operands);

    case E_V4SImode:
      if (register_operand (operands[0], E_V4SImode)
          && register_operand (operands[1], E_V4SImode)
          && 
#line 293 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_3 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && general_operand (operands[1], E_V4SImode))
        {
          if (
#line 313 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SImode, 0)))
            return gen_split_12 (insn, operands);
          if (
#line 327 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SImode, 1)))
            return gen_split_21 (insn, operands);
        }
      if (!register_operand (operands[0], E_V4SImode)
          || !memory_operand (operands[1], E_V4SImode)
          || !
#line 347 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_30 (insn, operands);

    case E_V4SFmode:
      if (register_operand (operands[0], E_V4SFmode)
          && register_operand (operands[1], E_V4SFmode)
          && 
#line 293 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_4 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && general_operand (operands[1], E_V4SFmode))
        {
          if (
#line 313 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SFmode, 0)))
            return gen_split_13 (insn, operands);
          if (
#line 327 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SFmode, 1)))
            return gen_split_22 (insn, operands);
        }
      if (!register_operand (operands[0], E_V4SFmode)
          || !memory_operand (operands[1], E_V4SFmode)
          || !
#line 347 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_31 (insn, operands);

    case E_V2DImode:
      if (register_operand (operands[0], E_V2DImode)
          && register_operand (operands[1], E_V2DImode)
          && 
#line 293 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_5 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && general_operand (operands[1], E_V2DImode))
        {
          if (
#line 313 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DImode, 0)))
            return gen_split_14 (insn, operands);
          if (
#line 327 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DImode, 1)))
            return gen_split_23 (insn, operands);
        }
      if (!register_operand (operands[0], E_V2DImode)
          || !memory_operand (operands[1], E_V2DImode)
          || !
#line 347 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_32 (insn, operands);

    case E_V2DFmode:
      if (register_operand (operands[0], E_V2DFmode)
          && register_operand (operands[1], E_V2DFmode)
          && 
#line 293 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_6 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V2DFmode)
          && general_operand (operands[1], E_V2DFmode))
        {
          if (
#line 313 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DFmode, 0)))
            return gen_split_15 (insn, operands);
          if (
#line 327 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DFmode, 1)))
            return gen_split_24 (insn, operands);
        }
      if (!register_operand (operands[0], E_V2DFmode)
          || !memory_operand (operands[1], E_V2DFmode)
          || !
#line 347 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_33 (insn, operands);

    case E_V1TImode:
      if (register_operand (operands[0], E_V1TImode)
          && register_operand (operands[1], E_V1TImode)
          && 
#line 293 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_7 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V1TImode)
          && general_operand (operands[1], E_V1TImode))
        {
          if (
#line 313 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TImode, 0)))
            return gen_split_16 (insn, operands);
          if (
#line 327 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TImode, 1)))
            return gen_split_25 (insn, operands);
        }
      if (!register_operand (operands[0], E_V1TImode)
          || !memory_operand (operands[1], E_V1TImode)
          || !
#line 347 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_34 (insn, operands);

    case E_V1TFmode:
      if (register_operand (operands[0], E_V1TFmode)
          && register_operand (operands[1], E_V1TFmode)
          && 
#line 293 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_8 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V1TFmode)
          && general_operand (operands[1], E_V1TFmode))
        {
          if (
#line 313 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TFmode, 0)))
            return gen_split_17 (insn, operands);
          if (
#line 327 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TFmode, 1)))
            return gen_split_26 (insn, operands);
        }
      if (!register_operand (operands[0], E_V1TFmode)
          || !memory_operand (operands[1], E_V1TFmode)
          || !
#line 347 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_35 (insn, operands);

    case E_TFmode:
      if (register_operand (operands[0], E_TFmode)
          && register_operand (operands[1], E_TFmode)
          && (
#line 293 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])) && 
#line 95 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return gen_split_9 (insn, operands);
      if (nonimmediate_operand (operands[0], E_TFmode)
          && general_operand (operands[1], E_TFmode))
        {
          if ((
#line 313 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], TFmode, 0)) && 
#line 95 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return gen_split_18 (insn, operands);
          if ((
#line 327 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], TFmode, 1)) && 
#line 95 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return gen_split_27 (insn, operands);
        }
      if (!register_operand (operands[0], E_TFmode)
          || !memory_operand (operands[1], E_TFmode)
          || !(
#line 347 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)) && 
#line 95 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return NULL;
      return gen_split_36 (insn, operands);

    case E_TImode:
      if (nonimmediate_operand (operands[0], E_TImode)
          && general_operand (operands[1], E_TImode))
        {
          if (
#line 1792 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && s390_split_ok_p (operands[0], operands[1], TImode, 0)))
            return gen_split_286 (insn, operands);
          if (
#line 1806 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && s390_split_ok_p (operands[0], operands[1], TImode, 1)))
            return gen_split_287 (insn, operands);
        }
      if (!register_operand (operands[0], E_TImode))
        return NULL;
      if (memory_operand (operands[1], E_TImode)
          && 
#line 1823 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return gen_split_288 (insn, operands);
      if (!register_operand (operands[1], E_TImode)
          || !
#line 1841 "../../gcc/config/s390/s390.md"
(TARGET_VX && reload_completed
   && GENERAL_REG_P (operands[0])
   && VECTOR_REG_P (operands[1])))
        return NULL;
      return gen_split_289 (insn, operands);

    case E_DImode:
      if (register_operand (operands[0], E_DImode))
        {
          if (register_operand (operands[1], E_DImode))
            {
              if (
#line 2188 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && ACCESS_REG_P (operands[0]) && reload_completed
   && dead_or_set_p (insn, operands[1])))
                return gen_split_292 (insn, operands);
              if (
#line 2199 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && ACCESS_REG_P (operands[0]) && reload_completed
   && !dead_or_set_p (insn, operands[1])))
                return gen_split_293 (insn, operands);
            }
          if (memory_operand (operands[1], E_DImode)
              && 
#line 2237 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed && TARGET_Z10
   && larl_operand (XEXP (operands[1], 0), SImode)))
            return gen_split_294 (insn, operands);
        }
      if (nonimmediate_operand (operands[0], E_DImode)
          && general_operand (operands[1], E_DImode))
        {
          if (
#line 2250 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DImode)
   && !s_operand (operands[1], DImode)
   && s390_split_ok_p (operands[0], operands[1], DImode, 0)))
            return gen_split_295 (insn, operands);
          if (
#line 2266 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DImode)
   && !s_operand (operands[1], DImode)
   && s390_split_ok_p (operands[0], operands[1], DImode, 1)))
            return gen_split_296 (insn, operands);
        }
      if (!register_operand (operands[0], E_DImode)
          || !memory_operand (operands[1], E_DImode)
          || !
#line 2282 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !FP_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_297 (insn, operands);

    case E_FPRX2mode:
      if (nonimmediate_operand (operands[0], E_FPRX2mode)
          && general_operand (operands[1], E_FPRX2mode))
        {
          if ((
#line 2825 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], FPRX2mode)
   && !s_operand (operands[1], FPRX2mode)
   && s390_split_ok_p (operands[0], operands[1], FPRX2mode, 0)) && 
#line 764 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_300 (insn, operands);
          if ((
#line 2841 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], FPRX2mode)
   && !s_operand (operands[1], FPRX2mode)
   && s390_split_ok_p (operands[0], operands[1], FPRX2mode, 1)) && 
#line 764 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_303 (insn, operands);
        }
      if (register_operand (operands[0], E_FPRX2mode)
          && memory_operand (operands[1], E_FPRX2mode))
        {
          if ((
#line 2857 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && GENERAL_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)) && 
#line 764 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_306 (insn, operands);
          if ((
#line 2873 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[1])
   && FP_REG_P (operands[0])) && 
#line 764 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_309 (insn, operands);
        }
      if (!memory_operand (operands[0], E_FPRX2mode)
          || !register_operand (operands[1], E_FPRX2mode)
          || !(
#line 2889 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[0])
   && FP_REG_P (operands[1])) && 
#line 764 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return NULL;
      return gen_split_312 (insn, operands);

    case E_TDmode:
      if (nonimmediate_operand (operands[0], E_TDmode)
          && general_operand (operands[1], E_TDmode))
        {
          if (
#line 2825 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TDmode)
   && !s_operand (operands[1], TDmode)
   && s390_split_ok_p (operands[0], operands[1], TDmode, 0)))
            return gen_split_301 (insn, operands);
          if (
#line 2841 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TDmode)
   && !s_operand (operands[1], TDmode)
   && s390_split_ok_p (operands[0], operands[1], TDmode, 1)))
            return gen_split_304 (insn, operands);
        }
      if (register_operand (operands[0], E_TDmode)
          && memory_operand (operands[1], E_TDmode))
        {
          if (
#line 2857 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && GENERAL_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
            return gen_split_307 (insn, operands);
          if (
#line 2873 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[1])
   && FP_REG_P (operands[0])))
            return gen_split_310 (insn, operands);
        }
      if (!memory_operand (operands[0], E_TDmode)
          || !register_operand (operands[1], E_TDmode)
          || !
#line 2889 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[0])
   && FP_REG_P (operands[1])))
        return NULL;
      return gen_split_313 (insn, operands);

    case E_DFmode:
      if (nonimmediate_operand (operands[0], E_DFmode)
          && general_operand (operands[1], E_DFmode))
        {
          if (
#line 2997 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DFmode)
   && !s_operand (operands[1], DFmode)
   && s390_split_ok_p (operands[0], operands[1], DFmode, 0)))
            return gen_split_314 (insn, operands);
          if (
#line 3013 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DFmode)
   && !s_operand (operands[1], DFmode)
   && s390_split_ok_p (operands[0], operands[1], DFmode, 1)))
            return gen_split_316 (insn, operands);
        }
      if (!register_operand (operands[0], E_DFmode)
          || !memory_operand (operands[1], E_DFmode)
          || !
#line 3029 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !FP_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_318 (insn, operands);

    case E_DDmode:
      if (nonimmediate_operand (operands[0], E_DDmode)
          && general_operand (operands[1], E_DDmode))
        {
          if (
#line 2997 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DDmode)
   && !s_operand (operands[1], DDmode)
   && s390_split_ok_p (operands[0], operands[1], DDmode, 0)))
            return gen_split_315 (insn, operands);
          if (
#line 3013 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DDmode)
   && !s_operand (operands[1], DDmode)
   && s390_split_ok_p (operands[0], operands[1], DDmode, 1)))
            return gen_split_317 (insn, operands);
        }
      if (!register_operand (operands[0], E_DDmode)
          || !memory_operand (operands[1], E_DDmode)
          || !
#line 3029 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !FP_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_319 (insn, operands);

    case E_QImode:
      if (!memory_operand (operands[0], E_QImode)
          || !memory_operand (operands[1], E_QImode)
          || !
#line 3119 "../../gcc/config/s390/s390.md"
(reload_completed))
        return NULL;
      return gen_split_320 (insn, operands);

    default:
      return NULL;
    }
}
