/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x1) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      return 0;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x1) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      return 1;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 2;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 3;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 4;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 5;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 6;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 7;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 8;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 9;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 10;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 11;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 12;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 13;

    case E_DImode:
      if (pattern10 (x1, 
E_DImode) != 0)
        return -1;
      return 14;

    case E_SImode:
      if (pattern10 (x1, 
E_SImode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (XVECLEN (x4, 0))
    {
    case 16:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x10 = XVECEXP (x4, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x11 = XVECEXP (x4, 0, 4);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x12 = XVECEXP (x4, 0, 5);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x13 = XVECEXP (x4, 0, 6);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x14 = XVECEXP (x4, 0, 7);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x4, 0, 8);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x16 = XVECEXP (x4, 0, 9);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x17 = XVECEXP (x4, 0, 10);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x18 = XVECEXP (x4, 0, 11);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x19 = XVECEXP (x4, 0, 12);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x20 = XVECEXP (x4, 0, 13);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x21 = XVECEXP (x4, 0, 14);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x22 = XVECEXP (x4, 0, 15);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x23 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x23) != USE
          || !nonimmediate_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !nonimmediate_operand (operands[1], E_V16QImode))
        return -1;
      x24 = XEXP (x23, 0);
      operands[2] = x24;
      if (!permute_pattern_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case 4:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x10 = XVECEXP (x4, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x23 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x23) != CLOBBER)
        return -1;
      x24 = XEXP (x23, 0);
      operands[2] = x24;
      if (!scratch_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!nonimmediate_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !nonimmediate_operand (operands[1], E_V4SImode))
            return -1;
          return 1;

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !nonimmediate_operand (operands[1], E_V4SFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 26)
    return -1;
  x6 = XVECEXP (x5, 0, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 1)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 1)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != LABEL_REF)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x10) != USE)
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x11) != USE)
    return -1;
  return 0;
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 1);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern91 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern91 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SUBREG)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SUBREG)
    return -1;
  return 0;
}

int
pattern107 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern113 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != ZERO_EXTEND
      || GET_MODE (x3) != i2
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern121 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern125 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  if (maybe_ne (SUBREG_BYTE (x5), i2)
      || GET_MODE (x5) != i3
      || !register_operand (operands[0], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x6) != i3
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern132 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x2, 1);
  if (XWINT (x5, 0) != 64L)
    return -1;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_DImode)
    return -1;
  return 0;
}

int
pattern138 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern144 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != SIGN_EXTEND)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != SIGN_EXTEND)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x4, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  x12 = XEXP (x5, 0);
  operands[2] = x12;
  x13 = XEXP (x8, 0);
  operands[0] = x13;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x7, 1);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x9, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  x17 = XEXP (x9, 1);
  if (!rtx_equal_p (x17, operands[2]))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_TImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern156 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern160 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern166 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern169 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern174 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern181 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern187 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern192 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern198 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern203 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_TImode)
      || GET_MODE (x1) != E_TImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_TImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_TImode)
    return -1;
  return 0;
}

int
pattern214 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern220 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern229 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern238 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern242 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !const0_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern248 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern255 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!const0_operand (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern266 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!nonimmediate_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_V8HImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_V2DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern289 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern297 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern23 (x1))
    {
    case 0:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 207; /* vec_sllv16qiv16qi */

    case 1:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 217; /* vec_sllv16qiv8hi */

    case 2:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 227; /* vec_sllv16qiv4si */

    case 3:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 208; /* vec_sllv8hiv16qi */

    case 4:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 218; /* vec_sllv8hiv8hi */

    case 5:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 228; /* vec_sllv8hiv4si */

    case 6:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 209; /* vec_sllv4siv16qi */

    case 7:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 219; /* vec_sllv4siv8hi */

    case 8:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 229; /* vec_sllv4siv4si */

    case 9:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 210; /* vec_sllv2div16qi */

    case 10:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 220; /* vec_sllv2div8hi */

    case 11:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 230; /* vec_sllv2div4si */

    case 12:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 211; /* vec_sllv1tiv16qi */

    case 13:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 221; /* vec_sllv1tiv8hi */

    case 14:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 231; /* vec_sllv1tiv4si */

    case 15:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 212; /* vec_slltiv16qi */

    case 16:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 222; /* vec_slltiv8hi */

    case 17:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 232; /* vec_slltiv4si */

    case 18:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 213; /* vec_sllv4sfv16qi */

    case 19:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 223; /* vec_sllv4sfv8hi */

    case 20:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 233; /* vec_sllv4sfv4si */

    case 21:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 214; /* vec_sllv2dfv16qi */

    case 22:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 224; /* vec_sllv2dfv8hi */

    case 23:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 234; /* vec_sllv2dfv4si */

    case 24:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 215; /* vec_sllv1tfv16qi */

    case 25:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 225; /* vec_sllv1tfv8hi */

    case 26:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 235; /* vec_sllv1tfv4si */

    case 27:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 216; /* vec_slltfv16qi */

    case 28:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 226; /* vec_slltfv8hi */

    case 29:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 236; /* vec_slltfv4si */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case NOT:
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern130 (x2, 
E_V1QImode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 794; /* notandv1qi3 */

        case E_V2QImode:
          if (pattern130 (x2, 
E_V2QImode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 795; /* notandv2qi3 */

        case E_V4QImode:
          if (pattern130 (x2, 
E_V4QImode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 796; /* notandv4qi3 */

        case E_V8QImode:
          if (pattern130 (x2, 
E_V8QImode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 797; /* notandv8qi3 */

        case E_V16QImode:
          if (pattern130 (x2, 
E_V16QImode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 798; /* notandv16qi3 */

        case E_V1HImode:
          if (pattern130 (x2, 
E_V1HImode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 799; /* notandv1hi3 */

        case E_V2HImode:
          if (pattern130 (x2, 
E_V2HImode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 800; /* notandv2hi3 */

        case E_V4HImode:
          if (pattern130 (x2, 
E_V4HImode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 801; /* notandv4hi3 */

        case E_V8HImode:
          if (pattern130 (x2, 
E_V8HImode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 802; /* notandv8hi3 */

        case E_V1SImode:
          if (pattern130 (x2, 
E_V1SImode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 803; /* notandv1si3 */

        case E_V2SImode:
          if (pattern130 (x2, 
E_V2SImode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 804; /* notandv2si3 */

        case E_V4SImode:
          if (pattern130 (x2, 
E_V4SImode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 805; /* notandv4si3 */

        case E_V1DImode:
          if (pattern130 (x2, 
E_V1DImode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 806; /* notandv1di3 */

        case E_V2DImode:
          if (pattern130 (x2, 
E_V2DImode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 807; /* notandv2di3 */

        case E_V1SFmode:
          if (pattern130 (x2, 
E_V1SFmode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 808; /* notandv1sf3 */

        case E_V2SFmode:
          if (pattern130 (x2, 
E_V2SFmode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 809; /* notandv2sf3 */

        case E_V4SFmode:
          if (pattern130 (x2, 
E_V4SFmode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 810; /* notandv4sf3 */

        case E_V1DFmode:
          if (pattern130 (x2, 
E_V1DFmode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 811; /* notandv1df3 */

        case E_V2DFmode:
          if (pattern130 (x2, 
E_V2DFmode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 812; /* notandv2df3 */

        case E_V1TFmode:
          if (pattern130 (x2, 
E_V1TFmode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 813; /* notandv1tf3 */

        case E_V1TImode:
          if (pattern130 (x2, 
E_V1TImode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 814; /* notandv1ti3 */

        case E_TImode:
          if (pattern130 (x2, 
E_TImode) != 0
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 815; /* notandti3 */

        case E_DImode:
          if (pnum_clobbers == NULL
              || pattern130 (x2, 
E_DImode) != 0
              || !(
#line 8648 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2394; /* *nanddi */

        case E_SImode:
          if (pnum_clobbers == NULL
              || pattern130 (x2, 
E_SImode) != 0
              || !
#line 8648 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2396; /* *nandsi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern81 (x2, 
E_V1QImode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 838; /* ior_notv1qi3 */

        case E_V2QImode:
          if (pattern81 (x2, 
E_V2QImode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 839; /* ior_notv2qi3 */

        case E_V4QImode:
          if (pattern81 (x2, 
E_V4QImode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 840; /* ior_notv4qi3 */

        case E_V8QImode:
          if (pattern81 (x2, 
E_V8QImode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 841; /* ior_notv8qi3 */

        case E_V16QImode:
          if (pattern81 (x2, 
E_V16QImode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 842; /* ior_notv16qi3 */

        case E_V1HImode:
          if (pattern81 (x2, 
E_V1HImode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 843; /* ior_notv1hi3 */

        case E_V2HImode:
          if (pattern81 (x2, 
E_V2HImode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 844; /* ior_notv2hi3 */

        case E_V4HImode:
          if (pattern81 (x2, 
E_V4HImode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 845; /* ior_notv4hi3 */

        case E_V8HImode:
          if (pattern81 (x2, 
E_V8HImode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 846; /* ior_notv8hi3 */

        case E_V1SImode:
          if (pattern81 (x2, 
E_V1SImode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 847; /* ior_notv1si3 */

        case E_V2SImode:
          if (pattern81 (x2, 
E_V2SImode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 848; /* ior_notv2si3 */

        case E_V4SImode:
          if (pattern81 (x2, 
E_V4SImode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 849; /* ior_notv4si3 */

        case E_V1DImode:
          if (pattern81 (x2, 
E_V1DImode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 850; /* ior_notv1di3 */

        case E_V2DImode:
          if (pattern81 (x2, 
E_V2DImode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 851; /* ior_notv2di3 */

        case E_V1SFmode:
          if (pattern81 (x2, 
E_V1SFmode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 852; /* ior_notv1sf3 */

        case E_V2SFmode:
          if (pattern81 (x2, 
E_V2SFmode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 853; /* ior_notv2sf3 */

        case E_V4SFmode:
          if (pattern81 (x2, 
E_V4SFmode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 854; /* ior_notv4sf3 */

        case E_V1DFmode:
          if (pattern81 (x2, 
E_V1DFmode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 855; /* ior_notv1df3 */

        case E_V2DFmode:
          if (pattern81 (x2, 
E_V2DFmode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 856; /* ior_notv2df3 */

        case E_V1TFmode:
          if (pattern81 (x2, 
E_V1TFmode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 857; /* ior_notv1tf3 */

        case E_V1TImode:
          if (pattern81 (x2, 
E_V1TImode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 858; /* ior_notv1ti3 */

        case E_TImode:
          if (pattern81 (x2, 
E_TImode) != 0
              || !
#line 1286 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 859; /* ior_notti3 */

        case E_DImode:
          if (pattern82 (x2, pnum_clobbers, 
E_DImode) != 0
              || !(
#line 8608 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2382; /* *orcdi */

        case E_SImode:
          if (pattern82 (x2, pnum_clobbers, 
E_SImode) != 0
              || !
#line 8608 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2384; /* *orcsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!nonzero_shift_count_operand (operands[4], E_DImode))
    return -1;
  if (
#line 4330 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
    return 1924; /* *extzvdi_nocc_lshiftrt */
  if (pnum_clobbers == NULL
      || !
#line 4330 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
    return -1;
  *pnum_clobbers = 1;
  return 1925; /* *extzvdi_clobbercc_lshiftrt */
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[4] = x5;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 2);
  operands[2] = x7;
  x8 = XEXP (x4, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      return recog_29 (x1, insn, pnum_clobbers);

    case NOT:
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern207 (x3, 
E_V1QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1QImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1435; /* *vec_sel0v1qi */
          if (!all_ones_operand (operands[4], E_V1QImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1473; /* *vec_sel1v1qi */

        case E_V2QImode:
          if (pattern207 (x3, 
E_V2QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2QImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1436; /* *vec_sel0v2qi */
          if (!all_ones_operand (operands[4], E_V2QImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1474; /* *vec_sel1v2qi */

        case E_V4QImode:
          if (pattern207 (x3, 
E_V4QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4QImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1437; /* *vec_sel0v4qi */
          if (!all_ones_operand (operands[4], E_V4QImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1475; /* *vec_sel1v4qi */

        case E_V8QImode:
          if (pattern207 (x3, 
E_V8QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V8QImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1438; /* *vec_sel0v8qi */
          if (!all_ones_operand (operands[4], E_V8QImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1476; /* *vec_sel1v8qi */

        case E_V16QImode:
          if (pattern207 (x3, 
E_V16QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V16QImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1439; /* *vec_sel0v16qi */
          if (!all_ones_operand (operands[4], E_V16QImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1477; /* *vec_sel1v16qi */

        case E_V1HImode:
          if (pattern207 (x3, 
E_V1HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1HImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1440; /* *vec_sel0v1hi */
          if (!all_ones_operand (operands[4], E_V1HImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1478; /* *vec_sel1v1hi */

        case E_V2HImode:
          if (pattern207 (x3, 
E_V2HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2HImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1441; /* *vec_sel0v2hi */
          if (!all_ones_operand (operands[4], E_V2HImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1479; /* *vec_sel1v2hi */

        case E_V4HImode:
          if (pattern207 (x3, 
E_V4HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4HImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1442; /* *vec_sel0v4hi */
          if (!all_ones_operand (operands[4], E_V4HImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1480; /* *vec_sel1v4hi */

        case E_V8HImode:
          if (pattern207 (x3, 
E_V8HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V8HImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1443; /* *vec_sel0v8hi */
          if (!all_ones_operand (operands[4], E_V8HImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1481; /* *vec_sel1v8hi */

        case E_V1SImode:
          if (pattern207 (x3, 
E_V1SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1SImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1444; /* *vec_sel0v1si */
          if (!all_ones_operand (operands[4], E_V1SImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1482; /* *vec_sel1v1si */

        case E_V2SImode:
          if (pattern207 (x3, 
E_V2SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2SImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1445; /* *vec_sel0v2si */
          if (!all_ones_operand (operands[4], E_V2SImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1483; /* *vec_sel1v2si */

        case E_V4SImode:
          if (pattern207 (x3, 
E_V4SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4SImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1446; /* *vec_sel0v4si */
          if (!all_ones_operand (operands[4], E_V4SImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1484; /* *vec_sel1v4si */

        case E_V1DImode:
          if (pattern207 (x3, 
E_V1DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1DImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1447; /* *vec_sel0v1di */
          if (!all_ones_operand (operands[4], E_V1DImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1485; /* *vec_sel1v1di */

        case E_V2DImode:
          if (pattern207 (x3, 
E_V2DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2DImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1448; /* *vec_sel0v2di */
          if (!all_ones_operand (operands[4], E_V2DImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1486; /* *vec_sel1v2di */

        case E_V1SFmode:
          if (pattern208 (x3, 
E_V1SFmode, 
E_V1SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1SImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1449; /* *vec_sel0v1sf */
          if (!all_ones_operand (operands[4], E_V1SImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1487; /* *vec_sel1v1sf */

        case E_V2SFmode:
          if (pattern208 (x3, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2SImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1450; /* *vec_sel0v2sf */
          if (!all_ones_operand (operands[4], E_V2SImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1488; /* *vec_sel1v2sf */

        case E_V4SFmode:
          if (pattern208 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4SImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1451; /* *vec_sel0v4sf */
          if (!all_ones_operand (operands[4], E_V4SImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1489; /* *vec_sel1v4sf */

        case E_V1DFmode:
          if (pattern208 (x3, 
E_V1DFmode, 
E_V1DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1DImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1452; /* *vec_sel0v1df */
          if (!all_ones_operand (operands[4], E_V1DImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1490; /* *vec_sel1v1df */

        case E_V2DFmode:
          if (pattern208 (x3, 
E_V2DFmode, 
E_V2DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2DImode)
              && 
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1453; /* *vec_sel0v2df */
          if (!all_ones_operand (operands[4], E_V2DImode)
              || !
#line 2590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1491; /* *vec_sel1v2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  switch (GET_MODE (x2))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonimmediate_operand (operands[3], E_DImode))
        return -1;
      if ((
#line 4482 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (DImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 64) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return 1950; /* *insvdi_nocc */
      if (pnum_clobbers == NULL
          || !(
#line 4482 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (DImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 64) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1951; /* *insvdi_clobbercc */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !nonimmediate_operand (operands[3], E_SImode))
        return -1;
      if (
#line 4482 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (SImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 32))
        return 1952; /* *insvsi_nocc */
      if (pnum_clobbers == NULL
          || !
#line 4482 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (SImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 32))
        return -1;
      *pnum_clobbers = 1;
      return 1953; /* *insvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_40 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case STRICT_LOW_PART:
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XEXP (x1, 1);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (subreg_register_operand (operands[0], E_QImode)
              && memory_operand (operands[1], E_QImode))
            return 1855; /* movstrictqi */
          break;

        case E_HImode:
          if (pnum_clobbers != NULL
              && subreg_register_operand (operands[0], E_HImode)
              && memory_operand (operands[1], E_HImode))
            {
              *pnum_clobbers = 1;
              return 1856; /* movstricthi */
            }
          break;

        case E_SImode:
          if (subreg_register_operand (operands[0], E_SImode)
              && general_operand (operands[1], E_SImode)
              && 
#line 2769 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 1857; /* movstrictsi */
          break;

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      res = recog_43 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case SUBREG:
      res = recog_44 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LABEL_REF:
      if (GET_CODE (x2) == PC)
        {
          x5 = XEXP (x4, 0);
          operands[0] = x5;
          return 2540; /* *jump64 */
        }
      break;

    default:
      break;
    }
  operands[1] = x4;
  operands[0] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (!nonimmediate_operand (operands[0], E_TImode)
          || !general_operand (operands[1], E_TImode)
          || !
#line 1765 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 1810; /* movti */

    case E_TFmode:
      if (!nonimmediate_operand (operands[0], E_TFmode)
          || !general_operand (operands[1], E_TFmode))
        return -1;
      if ((
#line 2793 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 764 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return 1858; /* *movtf_64 */
      if (!(
#line 2810 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 764 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 1861; /* *movtf_31 */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (SUBREG_BYTE (x3))
    {
    case 0:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case ROTATE:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!contiguous_bitmask_operand (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 4375 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1932; /* *risbgn_and_subregdi_rotr */
              if (pnum_clobbers != NULL
                  && 
#line 4375 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                {
                  *pnum_clobbers = 1;
                  return 1933; /* *risbg_and_subregdi_rotr */
                }
              if (
#line 4388 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return 1938; /* *risbgn_and_subregdi_rotl */
              if (pnum_clobbers == NULL
                  || !
#line 4388 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              *pnum_clobbers = 1;
              return 1939; /* *risbg_and_subregdi_rotl */

            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !const_int_operand (operands[2], E_HImode))
                return -1;
              if (
#line 4375 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1934; /* *risbgn_and_subregdi_rotr */
              if (pnum_clobbers != NULL
                  && 
#line 4375 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                {
                  *pnum_clobbers = 1;
                  return 1935; /* *risbg_and_subregdi_rotr */
                }
              if (
#line 4388 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return 1940; /* *risbgn_and_subregdi_rotl */
              if (pnum_clobbers == NULL
                  || !
#line 4388 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              *pnum_clobbers = 1;
              return 1941; /* *risbg_and_subregdi_rotl */

            case E_QImode:
              if (!register_operand (operands[1], E_QImode)
                  || !const_int_operand (operands[2], E_QImode))
                return -1;
              if (
#line 4375 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1936; /* *risbgn_and_subregdi_rotr */
              if (pnum_clobbers != NULL
                  && 
#line 4375 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                {
                  *pnum_clobbers = 1;
                  return 1937; /* *risbg_and_subregdi_rotr */
                }
              if (
#line 4388 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return 1942; /* *risbgn_and_subregdi_rotl */
              if (pnum_clobbers == NULL
                  || !
#line 4388 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              *pnum_clobbers = 1;
              return 1943; /* *risbg_and_subregdi_rotl */

            default:
              return -1;
            }

        case SUBREG:
        case MEM:
          operands[1] = x4;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) != CONST_INT
              || XWINT (x7, 0) != 2147483647L)
            return -1;
          if (
#line 5163 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2020; /* *llgt_sidi */
          if (pnum_clobbers == NULL
              || !
#line 5173 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2021; /* *llgt_sidi_split */

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      if (!contiguous_bitmask_nowrap_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x4))
        {
        case LSHIFTRT:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!nonzero_shift_count_operand (operands[2], E_DImode))
            return -1;
          if (
#line 4598 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
            return 1970; /* *trunc_sidi_and_subreg_lshrt_nocc */
          if (pnum_clobbers == NULL
              || !
#line 4598 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          *pnum_clobbers = 1;
          return 1971; /* *trunc_sidi_and_subreg_lshrt_clobbercc */

        case ZERO_EXTRACT:
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x4, 2);
          operands[2] = x8;
          if (!nonzero_shift_count_operand (operands[2], E_SImode))
            return -1;
          if (
#line 4612 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
            return 1972; /* *trunc_sidi_and_subreg_ze_nocc */
          if (pnum_clobbers == NULL
              || !
#line 4612 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          *pnum_clobbers = 1;
          return 1973; /* *trunc_sidi_and_subreg_ze_clobbercc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (!register_operand (operands[0], E_V1QImode)
              || GET_MODE (x3) != E_V1QImode
              || !register_operand (operands[1], E_V1QImode)
              || !
#line 1217 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 752; /* *absv1qi2 */

        case E_V2QImode:
          if (!register_operand (operands[0], E_V2QImode)
              || GET_MODE (x3) != E_V2QImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 1217 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 753; /* *absv2qi2 */

        case E_V4QImode:
          if (!register_operand (operands[0], E_V4QImode)
              || GET_MODE (x3) != E_V4QImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 1217 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 754; /* *absv4qi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 1217 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 755; /* *absv8qi2 */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 1217 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 756; /* *absv16qi2 */

        case E_V1HImode:
          if (!register_operand (operands[0], E_V1HImode)
              || GET_MODE (x3) != E_V1HImode
              || !register_operand (operands[1], E_V1HImode)
              || !
#line 1217 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 757; /* *absv1hi2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 1217 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 758; /* *absv2hi2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 1217 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 759; /* *absv4hi2 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 1217 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 760; /* *absv8hi2 */

        case E_V1SImode:
          if (!register_operand (operands[0], E_V1SImode)
              || GET_MODE (x3) != E_V1SImode
              || !register_operand (operands[1], E_V1SImode)
              || !
#line 1217 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 761; /* *absv1si2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 1217 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 762; /* *absv2si2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1217 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 763; /* *absv4si2 */

        case E_V1DImode:
          if (!register_operand (operands[0], E_V1DImode)
              || GET_MODE (x3) != E_V1DImode
              || !register_operand (operands[1], E_V1DImode)
              || !
#line 1217 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 764; /* *absv1di2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1217 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 765; /* *absv2di2 */

        case E_V1TImode:
          if (!register_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !register_operand (operands[1], E_V1TImode)
              || !(
#line 1217 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 766; /* *absv1ti2 */

        case E_TImode:
          if (!register_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !register_operand (operands[1], E_TImode)
              || !(
#line 1217 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 767; /* *absti2 */

        case E_V1SFmode:
          if (!register_operand (operands[0], E_V1SFmode)
              || GET_MODE (x3) != E_V1SFmode
              || !register_operand (operands[1], E_V1SFmode)
              || !(
#line 1986 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1270; /* absv1sf2 */

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !(
#line 1986 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1271; /* absv2sf2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !(
#line 1986 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1272; /* absv4sf2 */

        case E_V1DFmode:
          if (!register_operand (operands[0], E_V1DFmode)
              || GET_MODE (x3) != E_V1DFmode
              || !register_operand (operands[1], E_V1DFmode)
              || !
#line 1986 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1273; /* absv1df2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 1986 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1274; /* absv2df2 */

        case E_V1TFmode:
          if (!register_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !register_operand (operands[1], E_V1TFmode)
              || !(
#line 1986 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1275; /* absv1tf2 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || !register_operand (operands[1], E_TFmode))
            return -1;
          if ((
#line 1986 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1276; /* abstf2_vr */
          if ((
#line 9377 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 2459; /* *abstf2_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9388 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2465; /* *abstf2 */

        case E_DImode:
          if (pattern83 (x3, pnum_clobbers, 
E_DImode) != 0
              || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2449; /* absdi2 */

        case E_SImode:
          if (pattern83 (x3, pnum_clobbers, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 2450; /* abssi2 */

        case E_FPRX2mode:
          if (!register_operand (operands[0], E_FPRX2mode)
              || GET_MODE (x3) != E_FPRX2mode
              || !register_operand (operands[1], E_FPRX2mode))
            return -1;
          if ((
#line 9377 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 2460; /* *absfprx22_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9388 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2466; /* *absfprx22 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 9377 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2461; /* *absdf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9388 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2467; /* *absdf2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 9377 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2462; /* *abssf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9388 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2468; /* *abssf2 */

        case E_TDmode:
          if (!register_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !register_operand (operands[1], E_TDmode)
              || !(
#line 9377 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2463; /* *abstd2_nocc */

        case E_DDmode:
          if (!register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_DDmode)
              || !(
#line 9377 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2464; /* *absdd2_nocc */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pnum_clobbers == NULL
          || pattern66 (x3, 
E_SImode) != 0
          || !
#line 9300 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2444; /* *absdi2_sign */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (pattern11 (x3))
        {
        case 0:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
            return 991; /* *lshrv1qi3 */
          if (register_operand (operands[2], E_V1QImode)
              && 
#line 1566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1073; /* vlshrv1qi3 */
          break;

        case 1:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
            return 995; /* *lshrv2qi3 */
          if (register_operand (operands[2], E_V2QImode)
              && 
#line 1566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1074; /* vlshrv2qi3 */
          break;

        case 2:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
            return 999; /* *lshrv4qi3 */
          if (register_operand (operands[2], E_V4QImode)
              && 
#line 1566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1075; /* vlshrv4qi3 */
          break;

        case 3:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
            return 1003; /* *lshrv8qi3 */
          if (register_operand (operands[2], E_V8QImode)
              && 
#line 1566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1076; /* vlshrv8qi3 */
          break;

        case 4:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
            return 1007; /* *lshrv16qi3 */
          if (register_operand (operands[2], E_V16QImode)
              && 
#line 1566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1077; /* vlshrv16qi3 */
          break;

        case 5:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
            return 1011; /* *lshrv1hi3 */
          if (register_operand (operands[2], E_V1HImode)
              && 
#line 1566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1078; /* vlshrv1hi3 */
          break;

        case 6:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
            return 1015; /* *lshrv2hi3 */
          if (register_operand (operands[2], E_V2HImode)
              && 
#line 1566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1079; /* vlshrv2hi3 */
          break;

        case 7:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
            return 1019; /* *lshrv4hi3 */
          if (register_operand (operands[2], E_V4HImode)
              && 
#line 1566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1080; /* vlshrv4hi3 */
          break;

        case 8:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
            return 1023; /* *lshrv8hi3 */
          if (register_operand (operands[2], E_V8HImode)
              && 
#line 1566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1081; /* vlshrv8hi3 */
          break;

        case 9:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
            return 1027; /* *lshrv1si3 */
          if (register_operand (operands[2], E_V1SImode)
              && 
#line 1566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1082; /* vlshrv1si3 */
          break;

        case 10:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
            return 1031; /* *lshrv2si3 */
          if (register_operand (operands[2], E_V2SImode)
              && 
#line 1566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1083; /* vlshrv2si3 */
          break;

        case 11:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
            return 1035; /* *lshrv4si3 */
          if (register_operand (operands[2], E_V4SImode)
              && 
#line 1566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1084; /* vlshrv4si3 */
          break;

        case 12:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
            return 1039; /* *lshrv1di3 */
          if (register_operand (operands[2], E_V1DImode)
              && 
#line 1566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1085; /* vlshrv1di3 */
          break;

        case 13:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
            return 1043; /* *lshrv2di3 */
          if (register_operand (operands[2], E_V2DImode)
              && 
#line 1566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1086; /* vlshrv2di3 */
          break;

        case 14:
          if (
#line 9689 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2505; /* *lshrdi3_31 */
          if (
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2507; /* *lshrdi3 */
          break;

        case 15:
          return 2509; /* *lshrsi3 */

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      res = recog_28 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 32]
      || GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x2, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_QImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_DImode)
      || !
#line 4878 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0))
    return -1;
  return 2002; /* *insvdi_mem_reghigh */
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 1)
    return -1;
  switch (XINT (x2, 1))
    {
    case 8:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 36)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 36)
        return -1;
      return 2580; /* *set_tp */

    case 7:
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VOIDmode)
          || !
#line 11750 "../../gcc/config/s390/s390.md"
(GET_MODE (operands[0]) == Pmode))
        return -1;
      return 2614; /* main_pool */

    case 18:
      if (pattern35 (x1) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[0] = x3;
      if (!const_int_operand (operands[0], E_VOIDmode)
          || !
#line 12437 "../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
        return -1;
      return 2651; /* *tbeginc_1 */

    case 19:
      if (GET_MODE (x2) != E_CCRAWmode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 33
          || GET_MODE (x4) != E_CCRAWmode
          || !
#line 12454 "../../gcc/config/s390/s390.md"
(TARGET_HTM))
        return -1;
      return 2652; /* *tend_1 */

    case 21:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || !
#line 12494 "../../gcc/config/s390/s390.md"
(TARGET_HTM))
        return -1;
      return 2655; /* etnd */

    case 22:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!memory_operand (operands[0], E_DImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 12504 "../../gcc/config/s390/s390.md"
(TARGET_HTM))
        return -1;
      return 2656; /* ntstg */

    case 25:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || !
#line 12539 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2659; /* efpc */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern213 (x2) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == E_CCL1mode)
    {
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) == E_CCL1mode)
        {
          x6 = XEXP (x5, 1);
          if (rtx_equal_p (x6, operands[1]))
            {
              x7 = XEXP (x5, 0);
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern277 (x1, 
E_DImode) == 0
                      && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2280; /* adddi3_alc_carry1_cc */
                  break;

                case E_SImode:
                  if (pattern277 (x1, 
E_SImode) == 0)
                    return 2281; /* addsi3_alc_carry1_cc */
                  break;

                default:
                  break;
                }
            }
        }
    }
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XEXP (x5, 0);
  switch (GET_MODE (x7))
    {
    case E_DImode:
      if (pattern277 (x1, 
E_DImode) != 0
          || !(
#line 7056 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 2284; /* *adddi3_alc_carry2_cc */

    case E_SImode:
      if (pattern277 (x1, 
E_SImode) != 0
          || !
#line 7056 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
        return -1;
      return 2285; /* *addsi3_alc_carry2_cc */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ASHIFTRT:
      if (pattern148 (x1, 
NEG) != 0
          || !
#line 9090 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_match_ccmode (insn, CCAmode)))
        return -1;
      return 2416; /* *negdi2_sign_cc */

    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = recog_83 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[2] = x6;
      switch (pattern177 (x1, 
NEG))
        {
        case 0:
          if (!(
#line 9232 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2425; /* *negtf2_cc */

        case 1:
          if (!(
#line 9232 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2426; /* *negfprx22_cc */

        case 2:
          if (!
#line 9232 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2427; /* *negdf2_cc */

        case 3:
          if (!
#line 9232 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2428; /* *negsf2_cc */

        case 4:
          if (!(
#line 9243 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2429; /* *negtf2_cconly */

        case 5:
          if (!(
#line 9243 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2430; /* *negfprx22_cconly */

        case 6:
          if (!
#line 9243 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2431; /* *negdf2_cconly */

        case 7:
          if (!
#line 9243 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2432; /* *negsf2_cconly */

        default:
          return -1;
        }

    case ABS:
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case ASHIFTRT:
          if (GET_MODE (x7) != E_DImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != ASHIFT
              || GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != SUBREG
              || maybe_ne (SUBREG_BYTE (x9), 0)
              || GET_MODE (x9) != E_DImode)
            return -1;
          x10 = XEXP (x8, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x11 = XEXP (x7, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x6 = XEXP (x3, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x12 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x12) != SET)
            return -1;
          x13 = XEXP (x12, 1);
          if (pattern253 (x13, 
ABS, 
NEG) != 0)
            return -1;
          x14 = XEXP (x13, 0);
          x15 = XEXP (x14, 0);
          if (GET_CODE (x15) != SIGN_EXTEND
              || GET_MODE (x15) != E_DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_DImode)
            return -1;
          x16 = XEXP (x9, 0);
          operands[1] = x16;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x17 = XEXP (x12, 0);
          operands[0] = x17;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x18 = XEXP (x15, 0);
          if (!rtx_equal_p (x18, operands[1])
              || !
#line 9437 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2469; /* *negabsdi2_sign_cc */

        case REG:
        case SUBREG:
          operands[1] = x7;
          x6 = XEXP (x3, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (pattern191 (x1, 
ABS, 
NEG))
                {
                case 0:
                  switch (GET_MODE (x4))
                    {
                    case E_DImode:
                      if (pattern261 (x1, 
E_DImode) == 0
                          && (
#line 9459 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return 2471; /* *negabsdi2_cc */
                      break;

                    case E_SImode:
                      if (pattern261 (x1, 
E_SImode) == 0
                          && 
#line 9459 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                        return 2472; /* *negabssi2_cc */
                      break;

                    default:
                      break;
                    }
                  break;

                case 1:
                  if (GET_MODE (x5) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && scratch_operand (operands[0], E_DImode)
                      && (
#line 9470 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2473; /* *negabsdi2_cconly */
                  break;

                case 2:
                  if (GET_MODE (x5) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && scratch_operand (operands[0], E_SImode)
                      && 
#line 9470 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    return 2474; /* *negabssi2_cconly */
                  break;

                default:
                  break;
                }
            }
          operands[2] = x6;
          x12 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x12))
            {
            case SET:
              x13 = XEXP (x12, 1);
              if (GET_CODE (x13) != NEG)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != ABS)
                return -1;
              x17 = XEXP (x12, 0);
              operands[0] = x17;
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[1]))
                return -1;
              switch (GET_MODE (x4))
                {
                case E_TFmode:
                  if (pattern262 (x1, 
E_TFmode) != 0
                      || !(
#line 9496 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                    return -1;
                  return 2477; /* *negabstf2_cc */

                case E_FPRX2mode:
                  if (pattern262 (x1, 
E_FPRX2mode) != 0
                      || !(
#line 9496 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                    return -1;
                  return 2478; /* *negabsfprx22_cc */

                case E_DFmode:
                  if (pattern262 (x1, 
E_DFmode) != 0
                      || !
#line 9496 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2479; /* *negabsdf2_cc */

                case E_SFmode:
                  if (pattern262 (x1, 
E_SFmode) != 0
                      || !
#line 9496 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2480; /* *negabssf2_cc */

                default:
                  return -1;
                }

            case CLOBBER:
              x17 = XEXP (x12, 0);
              operands[0] = x17;
              switch (GET_MODE (x4))
                {
                case E_TFmode:
                  if (pattern240 (x5, 
E_TFmode) != 0
                      || !(
#line 9507 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                    return -1;
                  return 2481; /* *negabstf2_cconly */

                case E_FPRX2mode:
                  if (pattern240 (x5, 
E_FPRX2mode) != 0
                      || !(
#line 9507 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                    return -1;
                  return 2482; /* *negabsfprx22_cconly */

                case E_DFmode:
                  if (pattern240 (x5, 
E_DFmode) != 0
                      || !
#line 9507 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2483; /* *negabsdf2_cconly */

                case E_SFmode:
                  if (pattern240 (x5, 
E_SFmode) != 0
                      || !
#line 9507 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2484; /* *negabssf2_cconly */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case AND:
      res = recog_95 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case REG:
    case SUBREG:
    case MEM:
      res = recog_96 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PLUS:
      res = recog_97 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_98 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
      if (pattern38 (x1) == 0)
        {
          switch (GET_CODE (x3))
            {
            case SIGN_EXTEND:
              switch (pattern182 (x3))
                {
                case 0:
                  if (
#line 4207 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 1915; /* *cmpint_sign */
                  break;

                case 1:
                  if ((
#line 5108 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2017; /* *extendqidi2_short_displ */
                  break;

                case 2:
                  if (
#line 5108 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT))
                    return 2018; /* *extendqisi2_short_displ */
                  break;

                default:
                  break;
                }
              break;

            case ZERO_EXTEND:
              if (GET_MODE (x3) == E_SImode
                  && register_operand (operands[0], E_SImode))
                {
                  x4 = XEXP (x3, 0);
                  operands[1] = x4;
                  if (s_operand (operands[1], E_HImode)
                      && 
#line 5293 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                    return 2034; /* *zero_extendhisi2_31 */
                }
              break;

            default:
              break;
            }
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (register_operand (operands[0], E_DImode))
                {
                  if (s390_alc_comparison (operands[1], E_DImode)
                      && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2298; /* *sconddi */
                  if (s390_slb_comparison (operands[1], E_DImode)
                      && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2300; /* *sconddi_neg */
                }
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode))
                {
                  if (s390_alc_comparison (operands[1], E_SImode))
                    return 2299; /* *scondsi */
                  if (s390_slb_comparison (operands[1], E_SImode))
                    return 2301; /* *scondsi_neg */
                }
              break;

            default:
              break;
            }
        }
      break;

    case MULT:
      res = recog_99 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
      if (pnum_clobbers != NULL
          && XWINT (x3, 0) == 0L)
        {
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) == USE)
            {
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              if (memory_operand (operands[0], E_BLKmode))
                {
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (const_int_operand (operands[1], E_VOIDmode)
                      && 
#line 9001 "../../gcc/config/s390/s390.md"
(INTVAL (operands[1]) >= 1 && INTVAL (operands[1]) <= 256))
                    {
                      *pnum_clobbers = 1;
                      return 2409; /* *xc_zero */
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[1] = x3;
      if (!address_operand (operands[1], E_QImode)
          || !
#line 2598 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
        return -1;
      return 1852; /* force_la_31 */

    case PC:
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      operands[0] = x3;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (address_operand (operands[0], E_VOIDmode)
          && 
#line 10550 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK))
        return 2551; /* *casesi_jump */
      if (register_operand (operands[0], E_DImode)
          && (
#line 10569 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return 2552; /* casesi_jump_via_thunkdi_z10 */
      if (register_operand (operands[0], E_SImode)
          && (
#line 10569 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return 2553; /* casesi_jump_via_thunksi_z10 */
      if (pnum_clobbers == NULL)
        return -1;
      if (register_operand (operands[0], E_DImode)
          && (
#line 10587 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 2554; /* casesi_jump_via_thunkdi */
        }
      if (!register_operand (operands[0], E_SImode)
          || !(
#line 10587 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 2555; /* casesi_jump_via_thunksi */

    default:
      return -1;
    }
}

 int
recog_113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x3))
        {
        case CLOBBER:
          x4 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != COMPARE
              || GET_MODE (x5) != E_CCUmode)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_BLKmode)
            return -1;
          x8 = XEXP (x4, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCUmode)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          if (pattern97 (x9, 
E_SImode, 
0, 
USE) != 0)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          x11 = XEXP (x3, 0);
          operands[1] = x11;
          x12 = XEXP (x6, 0);
          operands[2] = x12;
          x13 = XEXP (x7, 0);
          operands[3] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern292 (
E_DImode) != 0
                  || !
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 1882; /* *cmpstrdi */

            case E_SImode:
              if (pattern292 (
E_SImode) != 0
                  || !
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 1883; /* *cmpstrsi */

            default:
              return -1;
            }

        case SET:
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != MEM
              || GET_MODE (x11) != E_BLKmode)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          if (pattern97 (x9, 
E_CCmode, 
33, 
CLOBBER) != 0)
            return -1;
          switch (pattern126 (x1))
            {
            case 0:
              if (!
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 1884; /* *movstr */

            case 1:
              if (!
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 1885; /* *movstr */

            case 2:
              if (!(
#line 3954 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1902; /* *setmem_long */

            case 3:
              if (!(
#line 3954 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1903; /* *setmem_long */

            case 4:
              if (!
#line 3982 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              return 1906; /* *setmem_long_31z */

            case 5:
              if (!(
#line 3967 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1904; /* *setmem_long_and */

            case 6:
              if (!(
#line 3967 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1905; /* *setmem_long_and */

            case 7:
              if (!
#line 3994 "../../gcc/config/s390/s390.md"
((!TARGET_64BIT && TARGET_ZARCH)))
                return -1;
              return 1907; /* *setmem_long_and_31z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x9 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x14 = XEXP (x2, 1);
      switch (GET_CODE (x14))
        {
        case SUBREG:
        case MEM:
          if (pattern74 (x1) != 0)
            return -1;
          switch (pattern194 (x1))
            {
            case 0:
              if (!(
#line 3590 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1886; /* *cpymem_short */

            case 1:
              if (!(
#line 3590 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1887; /* *cpymem_short */

            default:
              return -1;
            }

        case COMPARE:
          if (pattern73 (x1) != 0)
            return -1;
          switch (pattern194 (x1))
            {
            case 0:
              if (!(
#line 4039 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1908; /* *cmpmem_short */

            case 1:
              if (!(
#line 4039 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1909; /* *cmpmem_short */

            default:
              return -1;
            }

        case FLOAT_TRUNCATE:
          switch (pattern75 (x1))
            {
            case 0:
              if (!(
#line 5890 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2142; /* *trunctftd2 */

            case 1:
              if (!(
#line 5890 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2143; /* *truncfprx2td2 */

            case 2:
              if (!
#line 5890 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2144; /* *truncdftd2 */

            case 3:
              if (!
#line 5890 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2145; /* *truncsftd2 */

            case 4:
              if (!(
#line 5890 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2146; /* *trunctfdd2 */

            case 5:
              if (!(
#line 5890 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2147; /* *truncfprx2dd2 */

            case 6:
              if (!
#line 5890 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2148; /* *truncdfdd2 */

            case 7:
              if (!
#line 5890 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2149; /* *truncsfdd2 */

            case 8:
              if (!(
#line 5890 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2150; /* *trunctfsd2 */

            case 9:
              if (!(
#line 5890 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2151; /* *truncfprx2sd2 */

            case 10:
              if (!
#line 5890 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2152; /* *truncdfsd2 */

            case 11:
              if (!
#line 5890 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2153; /* *truncsfsd2 */

            case 12:
              if (!(
#line 5899 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2154; /* *trunctdtf2 */

            case 13:
              if (!(
#line 5899 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2158; /* *truncddtf2 */

            case 14:
              if (!(
#line 5899 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2162; /* *truncsdtf2 */

            case 15:
              if (!(
#line 5899 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2155; /* *trunctdfprx22 */

            case 16:
              if (!(
#line 5899 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2159; /* *truncddfprx22 */

            case 17:
              if (!(
#line 5899 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2163; /* *truncsdfprx22 */

            case 18:
              if (!
#line 5899 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2156; /* *trunctddf2 */

            case 19:
              if (!
#line 5899 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2160; /* *truncdddf2 */

            case 20:
              if (!
#line 5899 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2164; /* *truncsddf2 */

            case 21:
              if (!
#line 5899 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2157; /* *trunctdsf2 */

            case 22:
              if (!
#line 5899 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2161; /* *truncddsf2 */

            case 23:
              if (!
#line 5899 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2165; /* *truncsdsf2 */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          switch (pattern75 (x1))
            {
            case 0:
              if (!(
#line 5964 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2166; /* *extendtftd2 */

            case 1:
              if (!(
#line 5964 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2167; /* *extendfprx2td2 */

            case 2:
              if (!
#line 5964 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2168; /* *extenddftd2 */

            case 3:
              if (!
#line 5964 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2169; /* *extendsftd2 */

            case 4:
              if (!(
#line 5964 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2170; /* *extendtfdd2 */

            case 5:
              if (!(
#line 5964 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2171; /* *extendfprx2dd2 */

            case 6:
              if (!
#line 5964 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2172; /* *extenddfdd2 */

            case 7:
              if (!
#line 5964 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2173; /* *extendsfdd2 */

            case 8:
              if (!(
#line 5964 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2174; /* *extendtfsd2 */

            case 9:
              if (!(
#line 5964 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2175; /* *extendfprx2sd2 */

            case 10:
              if (!
#line 5964 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2176; /* *extenddfsd2 */

            case 11:
              if (!
#line 5964 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2177; /* *extendsfsd2 */

            case 12:
              if (!(
#line 5972 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2178; /* *extendtdtf2 */

            case 13:
              if (!(
#line 5972 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2182; /* *extendddtf2 */

            case 14:
              if (!(
#line 5972 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2186; /* *extendsdtf2 */

            case 15:
              if (!(
#line 5972 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2179; /* *extendtdfprx22 */

            case 16:
              if (!(
#line 5972 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2183; /* *extendddfprx22 */

            case 17:
              if (!(
#line 5972 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2187; /* *extendsdfprx22 */

            case 18:
              if (!
#line 5972 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2180; /* *extendtddf2 */

            case 19:
              if (!
#line 5972 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2184; /* *extenddddf2 */

            case 20:
              if (!
#line 5972 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2188; /* *extendsddf2 */

            case 21:
              if (!
#line 5972 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2181; /* *extendtdsf2 */

            case 22:
              if (!
#line 5972 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2185; /* *extendddsf2 */

            case 23:
              if (!
#line 5972 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2189; /* *extendsdsf2 */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          switch (pattern78 (x1))
            {
            case 0:
              if (!
#line 10067 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2535; /* *brxg_64bit */

            case 1:
              if (!
#line 10153 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              return 2537; /* *brx_31bit */

            case 2:
              if (!
#line 10110 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2536; /* *brx_64bit */

            case 3:
              return 2538; /* doloop_si64 */

            case 4:
              if (!
#line 10251 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2539; /* doloop_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern9 (x1))
    {
    case 0:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_147 (insn, operands);

    case 1:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_156 (insn, operands);

    case 2:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_165 (insn, operands);

    case 3:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_174 (insn, operands);

    case 4:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_183 (insn, operands);

    case 5:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_192 (insn, operands);

    case 6:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_201 (insn, operands);

    case 7:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_210 (insn, operands);

    case 8:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_219 (insn, operands);

    case 9:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_228 (insn, operands);

    case 10:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_237 (insn, operands);

    case 11:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_246 (insn, operands);

    case 12:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_255 (insn, operands);

    case 13:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_264 (insn, operands);

    case 14:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_273 (insn, operands);

    case 15:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_282 (insn, operands);

    case 16:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_148 (insn, operands);

    case 17:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_157 (insn, operands);

    case 18:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_166 (insn, operands);

    case 19:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_175 (insn, operands);

    case 20:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_184 (insn, operands);

    case 21:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_193 (insn, operands);

    case 22:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_202 (insn, operands);

    case 23:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_211 (insn, operands);

    case 24:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_220 (insn, operands);

    case 25:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_229 (insn, operands);

    case 26:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_238 (insn, operands);

    case 27:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_247 (insn, operands);

    case 28:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_256 (insn, operands);

    case 29:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_265 (insn, operands);

    case 30:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_274 (insn, operands);

    case 31:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_283 (insn, operands);

    case 32:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_149 (insn, operands);

    case 33:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_158 (insn, operands);

    case 34:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_167 (insn, operands);

    case 35:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_176 (insn, operands);

    case 36:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_185 (insn, operands);

    case 37:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_194 (insn, operands);

    case 38:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_203 (insn, operands);

    case 39:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_212 (insn, operands);

    case 40:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_221 (insn, operands);

    case 41:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_230 (insn, operands);

    case 42:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_239 (insn, operands);

    case 43:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_248 (insn, operands);

    case 44:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_257 (insn, operands);

    case 45:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_266 (insn, operands);

    case 46:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_275 (insn, operands);

    case 47:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_284 (insn, operands);

    default:
      return NULL;
    }
}
